/*   
    
    Ec  Vers  29.0    Copyright (C)   2001 Marc Dechico

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/
#include "ec_data.h"
/*****************************************************************************/
/* fonction controlant les cas d'echec, mat, pat              				 */
/*****************************************************************************/

/* calcul direction pour un ventuel echec par demasquage */
void ech_cal_dir_dem	(int i_cam_roi,int *pi_ech_dir_dem)
{
	int dx,dy;                                  /* difference en x/y 	*/
	int xr,yr;									/* coordonne roi 	 	*/
	int Id_r;									/* Id du roi 			 */

	Id_r=Id_roi[i_cam_roi];

	dx = 	(tpts_pie[i_cam_roi]+Id_r)->i_pos_x
			-
			pts_hst_pro->i_pos_ori_x;

	dy = 	(tpts_pie[i_cam_roi]+Id_r)->i_pos_y
			-
			pts_hst_pro->i_pos_ori_y;

	if (dx== 0)               /* roi et case sur mme colonne */
	{

		if (dy<0)            /* case en dessus */
		{
        	*pi_ech_dir_dem = 5;		 				/* cas_ctl_h      */
		}
		else                 /* case en dessous */
		{
        	*pi_ech_dir_dem = 6;		 				/* cas_ctl_b      */
		}
	}
	else
	{
		if (dy == 0) 		/* roi et case sur mme ligne */
		{
			if (dx<0)            /* case  droite */
			{
				*pi_ech_dir_dem = 7;		 				/* cas_ctl_d      */
			}
			else                 /* case  gauche  */
			{
   		     	*pi_ech_dir_dem = 8;		 				/* cas_ctl_g      */
			}

		}
		else
		{
			if (dx == dy) 		/* diagonal montante de gauche  droite */
			{
				if (dx>0)            /* case  gauche */
				{
		        	*pi_ech_dir_dem = 4;		 				/* cas_ctl_b_g      */
				}
				else                /* case  droite */
				{
					*pi_ech_dir_dem = 1;		 				/* cas_ctl_h_d      */
				}

			}
			else
			{
				if (dx == -dy)     	/* diagonal descendante de gauche  droite*/
				{
					if (dx>0)            /* case  gauche */
					{
			        	*pi_ech_dir_dem = 2;		 				/* cas_ctl_h_g      */
					}
					else                /* case  droite */
					{
			        	*pi_ech_dir_dem = 3;		 				/* cas_ctl_b_d      */
					}
				}
				else
				{
					*pi_ech_dir_dem = 0;
				}
			}
		}
	}

}

/* echec par la reine */
int ech_par_rei 	(int xd,int yd,int *pi_ech_dir)
{
	int dx,dy;                                  /* difference en x/y 	*/
	int xr,yr;									/* coordonne roi 	 	*/
	int x,y;									/* Compteur pour balayage*/
	int Id_r;									/* Id du roi 			 */


	Id_r=Id_roi[(pts_hst_pro->i_cam_adv)];

	xr = (tpts_pie[pts_hst_pro->i_cam_adv]+Id_r)->i_pos_x;
	dx = xr-xd;

	yr = (tpts_pie[pts_hst_pro->i_cam_adv]+Id_r)->i_pos_y;
	dy = yr-yd;

	*pi_ech_dir =0;

	if (dx== 0)               /* roi et reine sur mme colonne */
	{
		if (dy<0)            /* reine en dessus */
		{
			*pi_ech_dir = 5;
			for (y=yr+1;y<yd;y++)
			{
				if (ts_ech[xr][y].i_cam >=0)
				{
					return 0;
				}
			}
			return 1;
		}
		else                 /* reine en dessous */
		{
				*pi_ech_dir = 6;
				for (y=yr-1;y>yd;y--)
				{
					if (ts_ech[xr][y].i_cam >=0)
					{
						return 0;
					}
				}
				return 1;
		}
	}
	else
	{
		if (dy == 0) 		/* roi et reine sur mme ligne */
		{
			if (dx<0)            /* reine  droite */
			{
				*pi_ech_dir = 7;
				for (x=xr+1;x<xd;x++)
				{
					if (ts_ech[x][yr].i_cam >=0)
					{
						return 0;
					}
				}
				return 1;
			}
			else                 /* reine  gauche  */
			{
					*pi_ech_dir = 8;
					for (x=xr-1;x>xd;x--)
					{
						if (ts_ech[x][yr].i_cam >=0)
						{
							return 0;
						}
					}
					return 1;
			}
		}
		else
		{
			if (dx == dy) 		/* diagonal montante de gauche  droite*/
			{
				if (dx>0)            /* reine  gauche */
				{
					*pi_ech_dir = 4;
					for(x=xr-1,y=yr-1; x>xd;x--,y--)
					{
						if (ts_ech[x][y].i_cam >=0)
						{
							return 0;
						}
					}
					return 1;
				}
				else                /* reine  droite */
				{
					*pi_ech_dir = 1;
					for (x=xr+1,y=yr+1;x<xd;x++,y++)
					{
						if (ts_ech[x][y].i_cam >=0)
						{
							return 0;
						}
					}
					return 1;
				}
			}
			else
			{
				if (dx == -dy)     	/* diagonal descendante de gauche  droite */
				{
					if (dx>0)            /* reine  gauche */
					{
						*pi_ech_dir = 1;
						for (x=xr-1,y=yr+1;x>xd;x--,y++)
						{
							if (ts_ech[x][y].i_cam >=0)
							{
								return 0;
							}
						}
						return 1;
					}
					else                /* reine  droite */
					{
						*pi_ech_dir = 3;
						for (x=xr+1,y=yr-1;x<xd;x++,y--)
						{
							if (ts_ech[x][y].i_cam >=0)
							{
								return 0;
							}
						}
						return 1;
					}
				}
			}
		}
	}
	return 0;
}
/* echec par la tour */
int ech_par_tou 	(int xd,int yd,int *pi_ech_dir)
{
	int dx,dy;                                  /* difference en x/y 	*/
	int xr,yr;									/* coordonne roi 	 	*/
	int x,y;									/* Compteur pour balayage*/
	int Id_r;									/* Id du roi 			 */


	Id_r=Id_roi[(pts_hst_pro->i_cam_adv)];

	xr = (tpts_pie[pts_hst_pro->i_cam_adv]+Id_r)->i_pos_x;
	dx = xr-xd;

	yr = (tpts_pie[pts_hst_pro->i_cam_adv]+Id_r)->i_pos_y;
	dy = yr-yd;

    *pi_ech_dir = 0;

	if (dx == 0)       /* tour et roi sur la mme colone */
	{
		   if (dy<0)            /* tour en dessus */
			{
				*pi_ech_dir = 5;
				for (y=yr+1;y<yd;y++)
				{
					if (ts_ech[xr][y].i_cam >=0)
					{
						return 0;
					}
				}
				return 1;
			}
			else                 /* tour en dessous */
			{
					*pi_ech_dir = 6;
					for (y=yr-1;y>yd;y--)
					{
						if (ts_ech[xr][y].i_cam >=0)
						{
							return 0;
						}
					}
					return 1;
			}
	}
	else
	{
		if (dy == 0)             /* tour et roi sur la mme ligne */
		{
			if (dx<0)            /* tour  droite */
			{
				*pi_ech_dir = 7;
				for (x=xr+1;x<xd;x++)
				{
					if (ts_ech[x][yr].i_cam >=0)
					{
						return 0;
					}
				}
				return 1;
			}
			else                 /* tour  gauche  */
			{
				*pi_ech_dir = 8;
				for (x=xr-1;x>xd;x--)
				{
					if (ts_ech[x][yr].i_cam >=0)
					{
						return 0;
					}
				}
				return 1;
			}
		}
	}
	return 0;
}

/* echec par le  fou */
int ech_par_fou 	(int xd,int yd,int *pi_ech_dir)
{
	int dx,dy;                                  /* difference en x/y 	*/
	int xr,yr;									/* coordonne roi 	 	*/
	int x,y;									/* Compteur pour balayage*/
	int Id_r;									/* Id du roi 			 */


	Id_r=Id_roi[(pts_hst_pro->i_cam_adv)];

	xr = (tpts_pie[pts_hst_pro->i_cam_adv]+Id_r)->i_pos_x;
	dx = xr-xd;

	yr = (tpts_pie[pts_hst_pro->i_cam_adv]+Id_r)->i_pos_y;
	dy = yr-yd;



	if (dx==dy)              /* diagonal montante de gauche  droite */
	{

		if (dx>0)            /* fou  gauche */
		{
			*pi_ech_dir = 4;
			for(x=xr-1,y=yr-1; x>xd;x--,y--)
			{

				if (ts_ech[x][y].i_cam >=0)
				{
					return 0;
				}

			}
			return 1;
		}
		else                /* fou  droite */
		{
			*pi_ech_dir = 1;
			for (x=xr+1,y=yr+1;x<xd;x++,y++)
			{
				if (ts_ech[x][y].i_cam >=0)
				{
					return 0;
				}
			}
			return 1;
		}

	}
	else
	{
		if (dx == -dy)           /* diagonal descendante  de gauche  droite */
		{
			if (dx>0)            /* fou  gauche */
			{
				*pi_ech_dir = 2;
				for (x=xr-1,y=yr+1;x>xd;x--,y++)
				{
					if (ts_ech[x][y].i_cam >=0)
					{
						return 0;
					}
				}
				return 1;
			}
			else                /* fou  droite */
			{
				*pi_ech_dir = 3;
				for (x=xr+1,y=yr-1;x<xd;x++,y--)
				{
					if (ts_ech[x][y].i_cam >=0)
					{
						return 0;
					}
				}
				return 1;
			}
		}
	}
	return 0;
}

/* echec par le  cavalier */
int ech_par_cav 	(int xd,int yd,int *pi_ech_dir)
{
	int dx,dy;                                  /* difference en x/y 	*/

	dx =
	pts_hst_pro->i_pos_x_R_c_a   /* position x du roi camp adverse */
	-
	xd					         /* position x de la piece mvtee */
	;

	dy =
	pts_hst_pro->i_pos_y_R_c_a   /* position y du roi camp adverse */
	-
	yd  					     /* position y de la piece mvtee */
	;

	if ((abs(dx)==1 && abs(dy)==2)||(abs(dx) ==  2 && abs(dy) == 1))
	{
		dx +=2;
		dy +=2;
		/* tableau de correpondance coordonn cavalier/roi <-> ech_dir */
		*pi_ech_dir = ti_ech_dir_cav[dx][dy];
		return 1;
	}
	else
	{
		*pi_ech_dir = 0;
		return 0;
	}

}

/* echec par pion couleur blanc */
int ech_par_pio_0 	(int xd, int yd,int *pi_ech_dir)
{
	int dx,dy;                                  /* difference en x/y 	*/
	int xr,yr;									/* coordonne roi 	 	*/
	int Id_r;									/* Id du roi 			 */


   	Id_r=Id_roi[(pts_hst_pro->i_cam_adv)];

	xr = (tpts_pie[pts_hst_pro->i_cam_adv]+Id_r)->i_pos_x;
	xd = pts_hst_pro->i_pos_x;
	dx = xr-xd;

	yr = (tpts_pie[pts_hst_pro->i_cam_adv]+Id_r)->i_pos_y;
	yd = pts_hst_pro->i_pos_y;
	dy = yr-yd;

	if (dy== 1)
	{
		switch (dx)
		{
			case 1:
				 *pi_ech_dir = 18;   return 1;
			case -1:
				 *pi_ech_dir = 17;   return 1;
			default :
			     *pi_ech_dir = 0;    return 0;

		}
	}
    else
    {
		*pi_ech_dir = 0;
		return 0;
	}
}
/* echec par pion couleur noir */
int ech_par_pio_1 	(int xd, int yd, int *pi_ech_dir)
{
	int dx,dy;                                  /* difference en x/y 	*/
	int xr,yr;									/* coordonne roi 	 	*/
	int Id_r;									/* Id du roi 			 */

	/* pointeur historique */
	/*pts_hst_pro = &ts_hst_pro[i_pro_sim_act];
*/

   	Id_r=Id_roi[(pts_hst_pro->i_cam_adv)];

	xr = (tpts_pie[pts_hst_pro->i_cam_adv]+Id_r)->i_pos_x;
	dx = xr-xd;

	yr = (tpts_pie[pts_hst_pro->i_cam_adv]+Id_r)->i_pos_y;
	dy = yr-yd;
	if (dy== -1)
	{
		switch (dx)
		{
			case 1:
				 *pi_ech_dir = 18;   return 1;
			case -1:
			     *pi_ech_dir = 17;   return 1;
			default :
			     *pi_ech_dir = 0;    return 0;

		}
	}
    else
    {
		*pi_ech_dir = 0;
    	return 0;
    }


}

/* controle si roi se retrouve echec */
int cas_ctl_sta     (int x,int y,int i_cam_adv)
{

	if (cas_ctl_cav_h_d (x,y,i_cam_adv))
		return 1;
	if (cas_ctl_cav_d_h (x,y,i_cam_adv))
		return 1;
	if (cas_ctl_cav_d_b (x,y,i_cam_adv))
		return 1;
	if (cas_ctl_cav_b_d (x,y,i_cam_adv))
		return 1;
	if (cas_ctl_cav_b_g (x,y,i_cam_adv))
		return 1;
	if (cas_ctl_cav_g_b (x,y,i_cam_adv))
		return 1;
	if (cas_ctl_cav_g_h (x,y,i_cam_adv))
		return 1;
	if (cas_ctl_cav_h_g (x,y,i_cam_adv))
		return 1;

	if (cas_ctl_roi_h (x,y,i_cam_adv))
		return 1;
	if (cas_ctl_roi_h_d (x,y,i_cam_adv))
		return 1;
	if (cas_ctl_roi_d (x,y,i_cam_adv))
		return 1;
	if (cas_ctl_roi_b_d (x,y,i_cam_adv))
		return 1;
	if (cas_ctl_roi_b (x,y,i_cam_adv))
		return 1;
	if (cas_ctl_roi_b_g (x,y,i_cam_adv))
		return 1;
	if (cas_ctl_roi_g (x,y,i_cam_adv))
		return 1;
	if (cas_ctl_roi_h_g (x,y,i_cam_adv))
		return 1;


	return 0;
}

/* cas ctl spcifique  une position dans l'echiquier */
/* case exterieur */
int cas_ctl_pos_c_h_g	  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

	 /* tour fou reine 	*/
	 /* oblique */
	 #include"ccpo_db.c"
	 /* droite */
	 #include"ccpd_d.c"
	 #include"ccpd_b.c"

	 /* cavalier 		*/
	 #include"ccpc_db.c"
	 #include"ccpc_bd.c"

     /* pion   			*/
     #include"ccpp_d.c"

     /* roi  		*/
     #include"ccpr_d.c"
     #include"ccpr_bd.c"
     #include"ccpr_b.c"


	return 0;
}
int cas_ctl_pos_c_h_d	  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

	 /* tour fou reine 	*/
	 /* oblique */
	 #include"ccpo_gb.c"

	 /* droite */
	 #include"ccpd_b.c"
     #include"ccpd_g.c"

	 /* cavalier 		*/
	 #include"ccpc_bg.c"
	 #include"ccpc_gb.c"

	 /* pion   			*/
	 #include"ccpp_d.c"

	 /* roi  		*/
	 #include"ccpr_b.c"
	 #include"ccpr_bg.c"
	 #include"ccpr_g.c"


	return 0;
}
int cas_ctl_pos_c_b_d	  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

	 /* tour fou reine 	*/
	 /* oblique */
     #include"ccpo_gh.c"
     /* droite */
     #include"ccpd_h.c"
     #include"ccpd_g.c"

     /* cavalier 		*/
	 #include"ccpc_gh.c"
     #include"ccpc_hg.c"

     /* pion   			*/
     #include"ccpp_g.c"

     /* roi  		*/
	 #include"ccpr_h.c"
	 #include"ccpr_g.c"
	 #include"ccpr_hg.c"


	return 0;
}
int cas_ctl_pos_c_b_g  	  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
     /* oblique */
	 #include"ccpo_dh.c"
     /* droite */
     #include"ccpd_h.c"
     #include"ccpd_d.c"

	 /* cavalier 		*/
     #include"ccpc_hd.c"
     #include"ccpc_dh.c"

     /* pion   			*/
     #include"ccpp_d.c"

     /* roi  		*/
	 #include"ccpr_h.c"
     #include"ccpr_hd.c"
     #include"ccpr_d.c"


	return 0;
}
int cas_ctl_pos_h_g		  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

	 /* tour fou reine 	*/
	 /* oblique */
	 #include"ccpo_db.c"
	 #include"ccpo_gb.c"
	 /* droite */
     #include"ccpd_d.c"
     #include"ccpd_b.c"
     #include"ccpd_g.c"

     /* cavalier 		*/
     #include"ccpc_db.c"
     #include"ccpc_bd.c"
     #include"ccpc_bg.c"

     /* pion   			*/
     #include"ccpp_d.c"
     #include"ccpp_g.c"

	 /* roi  		*/
	 #include"ccpr_d.c"
	 #include"ccpr_bd.c"
	 #include"ccpr_b.c"
	 #include"ccpr_bg.c"
	 #include"ccpr_g.c"


	return 0;
}
int cas_ctl_pos_h_d		  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
     /* oblique */
     #include"ccpo_db.c"
     #include"ccpo_gb.c"
     /* droite */
     #include"ccpd_d.c"
     #include"ccpd_b.c"
     #include"ccpd_g.c"

     /* cavalier 		*/
     #include"ccpc_bd.c"
     #include"ccpc_bg.c"
     #include"ccpc_gb.c"

     /* pion   			*/
     #include"ccpp_d.c"
     #include"ccpp_g.c"

	 /* roi  		*/
     #include"ccpr_d.c"
     #include"ccpr_bd.c"
     #include"ccpr_b.c"
     #include"ccpr_bg.c"
	 #include"ccpr_g.c"


	return 0;
}
int cas_ctl_pos_d_h		  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
     /* oblique */
     #include"ccpo_gb.c"
     #include"ccpo_gh.c"
     /* droite */
     #include"ccpd_h.c"
     #include"ccpd_b.c"
     #include"ccpd_g.c"

     /* cavalier 		*/
     #include"ccpc_bg.c"
     #include"ccpc_gb.c"
     #include"ccpc_gh.c"

     /* pion   			*/
     #include"ccpp_g.c"

     /* roi  		*/
	 #include"ccpr_h.c"
     #include"ccpr_b.c"
     #include"ccpr_bg.c"
	 #include"ccpr_g.c"
     #include"ccpr_hg.c"


	return 0;
}
int cas_ctl_pos_d_b		  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
     /* oblique */
     #include"ccpo_gb.c"
     #include"ccpo_gh.c"
     /* droite */
     #include"ccpd_h.c"
     #include"ccpd_b.c"
     #include"ccpd_g.c"

	 /* cavalier 		*/
     #include"ccpc_gb.c"
	 #include"ccpc_gh.c"
	 #include"ccpc_hg.c"

	 /* pion   			*/
	 #include"ccpp_g.c"

	 /* roi  		*/
	 #include"ccpr_h.c"
	 #include"ccpr_b.c"
	 #include"ccpr_bg.c"
	 #include"ccpr_g.c"
	 #include"ccpr_hg.c"


	return 0;
}
int cas_ctl_pos_b_d		  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
     /* oblique */
     #include"ccpo_dh.c"
     #include"ccpo_gh.c"
     /* droite */
     #include"ccpd_h.c"
     #include"ccpd_d.c"
     #include"ccpd_g.c"

     /* cavalier 		*/
	 #include"ccpc_hd.c"
     #include"ccpc_gh.c"
     #include"ccpc_hg.c"

     /* pion   			*/
	 #include"ccpp_d.c"
     #include"ccpp_g.c"

	 /* roi  		*/
	 #include"ccpr_h.c"
     #include"ccpr_hd.c"
     #include"ccpr_d.c"
	 #include"ccpr_g.c"
     #include"ccpr_hg.c"


	return 0;
}
int cas_ctl_pos_b_g		  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
     /* oblique */
     #include"ccpo_dh.c"
     #include"ccpo_gh.c"
     /* droite */
     #include"ccpd_h.c"
     #include"ccpd_d.c"
     #include"ccpd_g.c"

     /* cavalier 		*/
	 #include"ccpc_hd.c"
     #include"ccpc_dh.c"
     #include"ccpc_hg.c"

     /* pion   			*/
     #include"ccpp_d.c"
     #include"ccpp_g.c"

	 /* roi  		*/
	 #include"ccpr_h.c"
     #include"ccpr_hd.c"
     #include"ccpr_d.c"
     #include"ccpr_g.c"
     #include"ccpr_hg.c"


	return 0;
}
int cas_ctl_pos_g_b		  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
     /* oblique */
     #include"ccpo_dh.c"
     #include"ccpo_db.c"
     /* droite */
     #include"ccpd_h.c"
     #include"ccpd_d.c"
     #include"ccpd_b.c"

     /* cavalier 		*/
	 #include"ccpc_hd.c"
     #include"ccpc_dh.c"
     #include"ccpc_db.c"

     /* pion   			*/
	 #include"ccpp_d.c"

     /* roi  		*/
	 #include"ccpr_h.c"
     #include"ccpr_hd.c"
     #include"ccpr_d.c"
     #include"ccpr_bd.c"
     #include"ccpr_b.c"


	return 0;
}
int cas_ctl_pos_g_h		  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
     /* oblique */
     #include"ccpo_dh.c"
     #include"ccpo_db.c"
     /* droite */
     #include"ccpd_h.c"
     #include"ccpd_d.c"
     #include"ccpd_b.c"

     /* cavalier 		*/
     #include"ccpc_dh.c"
	 #include"ccpc_db.c"
     #include"ccpc_bd.c"

	 /* pion   			*/
     #include"ccpp_d.c"

     /* roi  		*/
	 #include"ccpr_h.c"
	 #include"ccpr_hd.c"
	 #include"ccpr_d.c"
	 #include"ccpr_bd.c"
	 #include"ccpr_b.c"


	return 0;
}
int cas_ctl_pos_h		  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

	 /* tour fou reine 	*/
	 /* oblique */
	 #include"ccpo_db.c"
	 #include"ccpo_gb.c"
	 /* droite */
	 #include"ccpd_d.c"
	 #include"ccpd_b.c"
	 #include"ccpd_g.c"

	 /* cavalier 		*/
	 #include"ccpc_db.c"
	 #include"ccpc_bd.c"
	 #include"ccpc_bg.c"
	 #include"ccpc_gb.c"

     /* pion   			*/
     #include"ccpp_d.c"
     #include"ccpp_g.c"

	 /* roi  		*/
	 #include"ccpr_d.c"
	 #include"ccpr_bd.c"
	 #include"ccpr_b.c"
	 #include"ccpr_bg.c"
	 #include"ccpr_g.c"


	return 0;
}
int cas_ctl_pos_d		  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
     /* oblique */
     #include"ccpo_gb.c"
     #include"ccpo_gh.c"
     /* droite */
     #include"ccpd_h.c"
     #include"ccpd_b.c"
     #include"ccpd_g.c"

     /* cavalier 		*/
	 #include"ccpc_bg.c"
	 #include"ccpc_gb.c"
     #include"ccpc_gh.c"
     #include"ccpc_hg.c"

     /* pion   			*/
     #include"ccpp_g.c"

	 /* roi  		*/
	 #include"ccpr_h.c"
     #include"ccpr_b.c"
     #include"ccpr_bg.c"
     #include"ccpr_g.c"
     #include"ccpr_hg.c"


	return 0;
}
int cas_ctl_pos_b		  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
     /* oblique */
     #include"ccpo_dh.c"
     #include"ccpo_gh.c"
     /* droite */
     #include"ccpd_h.c"
     #include"ccpd_d.c"
     #include"ccpd_g.c"

     /* cavalier 		*/
     #include"ccpc_hd.c"
	 #include"ccpc_dh.c"
     #include"ccpc_gh.c"
     #include"ccpc_hg.c"

     /* pion   			*/
     #include"ccpp_d.c"
     #include"ccpp_g.c"

     /* roi  		*/
	 #include"ccpr_h.c"
     #include"ccpr_hd.c"
     #include"ccpr_d.c"
     #include"ccpr_g.c"
     #include"ccpr_hg.c"


	return 0;
}
int cas_ctl_pos_g		  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
     /* oblique */
     #include"ccpo_dh.c"
     #include"ccpo_db.c"
     /* droite */
	 #include"ccpd_h.c"
     #include"ccpd_d.c"
     #include"ccpd_b.c"

     /* cavalier 		*/
	 #include"ccpc_hd.c"
     #include"ccpc_dh.c"
     #include"ccpc_db.c"
     #include"ccpc_bd.c"

     /* pion   			*/
     #include"ccpp_d.c"

	 /* roi  		*/
	 #include"ccpr_h.c"
     #include"ccpr_hd.c"
     #include"ccpr_d.c"
     #include"ccpr_bd.c"
     #include"ccpr_b.c"


	return 0;
}

/* case interieur */
int cas_ctl_pos_i_c_h_g	  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
	 /* oblique */
     #include"ccpo_dh.c"
     #include"ccpo_db.c"
     #include"ccpo_gb.c"
     #include"ccpo_gh.c"
     /* droite */
     #include"ccpd_h.c"
	 #include"ccpd_d.c"
     #include"ccpd_b.c"
     #include"ccpd_g.c"

     /* cavalier 		*/
     #include"ccpc_dh.c"
     #include"ccpc_db.c"
     #include"ccpc_bd.c"
     #include"ccpc_bg.c"

	 /* pion   			*/
     #include"ccpp_d.c"
     #include"ccpp_g.c"

     /* roi  		*/
	 #include"ccpr_h.c"
     #include"ccpr_hd.c"
     #include"ccpr_d.c"
     #include"ccpr_bd.c"
     #include"ccpr_b.c"
	 #include"ccpr_bg.c"
     #include"ccpr_g.c"
     #include"ccpr_hg.c"


	return 0;
}
int cas_ctl_pos_i_c_h_d	  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
	 /* oblique */
     #include"ccpo_dh.c"
     #include"ccpo_db.c"
     #include"ccpo_gb.c"
     #include"ccpo_gh.c"
     /* droite */
     #include"ccpd_h.c"
     #include"ccpd_d.c"
     #include"ccpd_b.c"
     #include"ccpd_g.c"

     /* cavalier 		*/
     #include"ccpc_bd.c"
     #include"ccpc_bg.c"
     #include"ccpc_gb.c"
     #include"ccpc_gh.c"

	 /* pion   			*/
     #include"ccpp_d.c"
     #include"ccpp_g.c"

     /* roi  		*/
	 #include"ccpr_h.c"
     #include"ccpr_hd.c"
     #include"ccpr_d.c"
	 #include"ccpr_bd.c"
	 #include"ccpr_b.c"
     #include"ccpr_bg.c"
     #include"ccpr_g.c"
     #include"ccpr_hg.c"


	return 0;
}
int cas_ctl_pos_i_c_b_d	  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
     /* oblique */
     #include"ccpo_dh.c"
     #include"ccpo_db.c"
     #include"ccpo_gb.c"
     #include"ccpo_gh.c"
     /* droite */
     #include"ccpd_h.c"
     #include"ccpd_d.c"
     #include"ccpd_b.c"
     #include"ccpd_g.c"

     /* cavalier 		*/
     #include"ccpc_hd.c"
	 #include"ccpc_gb.c"
     #include"ccpc_gh.c"
     #include"ccpc_hg.c"

	 /* pion   			*/
     #include"ccpp_d.c"
     #include"ccpp_g.c"

     /* roi  		*/
	 #include"ccpr_h.c"
     #include"ccpr_hd.c"
     #include"ccpr_d.c"
     #include"ccpr_bd.c"
     #include"ccpr_b.c"
     #include"ccpr_bg.c"
     #include"ccpr_g.c"
     #include"ccpr_hg.c"


	return 0;
}
int cas_ctl_pos_i_c_b_g	  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
     /* oblique */
     #include"ccpo_dh.c"
     #include"ccpo_db.c"
     #include"ccpo_gb.c"
     #include"ccpo_gh.c"
     /* droite */
	 #include"ccpd_h.c"
     #include"ccpd_d.c"
	 #include"ccpd_b.c"
     #include"ccpd_g.c"

     /* cavalier 		*/
     #include"ccpc_hd.c"
     #include"ccpc_dh.c"
     #include"ccpc_db.c"
     #include"ccpc_hg.c"

	 /* pion   			*/
     #include"ccpp_d.c"
     #include"ccpp_g.c"

     /* roi  		*/
	 #include"ccpr_h.c"
     #include"ccpr_hd.c"
     #include"ccpr_d.c"
     #include"ccpr_bd.c"
	 #include"ccpr_b.c"
     #include"ccpr_bg.c"
     #include"ccpr_g.c"
     #include"ccpr_hg.c"


	return 0;
}
int cas_ctl_pos_i_h		  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

	 /* tour fou reine 	*/
     /* oblique */
     #include"ccpo_dh.c"
     #include"ccpo_db.c"
     #include"ccpo_gb.c"
     #include"ccpo_gh.c"
     /* droite */
     #include"ccpd_h.c"
     #include"ccpd_d.c"
     #include"ccpd_b.c"
     #include"ccpd_g.c"

     /* cavalier 		*/
     #include"ccpc_dh.c"
     #include"ccpc_db.c"
     #include"ccpc_bd.c"
     #include"ccpc_bg.c"
     #include"ccpc_gb.c"
	 #include"ccpc_gh.c"

	 /* pion   			*/
     #include"ccpp_d.c"
     #include"ccpp_g.c"

     /* roi  		*/
	 #include"ccpr_h.c"
     #include"ccpr_hd.c"
     #include"ccpr_d.c"
     #include"ccpr_bd.c"
     #include"ccpr_b.c"
     #include"ccpr_bg.c"
     #include"ccpr_g.c"
     #include"ccpr_hg.c"


	return 0;
}
int cas_ctl_pos_i_d		  (int xx, int yy)
{
	 int i_cam_adv;
     int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

	 /* tour fou reine 	*/
	 /* oblique */
	 #include"ccpo_dh.c"
	 #include"ccpo_db.c"
	 #include"ccpo_gb.c"
	 #include"ccpo_gh.c"
	 /* droite */
	 #include"ccpd_h.c"
	 #include"ccpd_d.c"
	 #include"ccpd_b.c"
	 #include"ccpd_g.c"

     /* cavalier 		*/
     #include"ccpc_hd.c"
     #include"ccpc_bd.c"
     #include"ccpc_bg.c"
     #include"ccpc_gb.c"
     #include"ccpc_gh.c"
	 #include"ccpc_hg.c"

     /* pion   			*/
     #include"ccpp_d.c"
     #include"ccpp_g.c"

     /* roi  		*/
	 #include"ccpr_h.c"
     #include"ccpr_hd.c"
     #include"ccpr_d.c"
     #include"ccpr_bd.c"
     #include"ccpr_b.c"
     #include"ccpr_bg.c"
	 #include"ccpr_g.c"
     #include"ccpr_hg.c"


	return 0;
}
int cas_ctl_pos_i_b		  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
     /* oblique */
	 #include"ccpo_dh.c"
     #include"ccpo_db.c"
     #include"ccpo_gb.c"
     #include"ccpo_gh.c"
     /* droite */
     #include"ccpd_h.c"
     #include"ccpd_d.c"
     #include"ccpd_b.c"
     #include"ccpd_g.c"

     /* cavalier 		*/
     #include"ccpc_hd.c"
     #include"ccpc_dh.c"
     #include"ccpc_db.c"
     #include"ccpc_gb.c"
     #include"ccpc_gh.c"
	 #include"ccpc_hg.c"

     /* pion   			*/
     #include"ccpp_d.c"
	 #include"ccpp_g.c"

     /* roi  		*/
	 #include"ccpr_h.c"
     #include"ccpr_hd.c"
     #include"ccpr_d.c"
     #include"ccpr_bd.c"
     #include"ccpr_b.c"
     #include"ccpr_bg.c"
     #include"ccpr_g.c"
     #include"ccpr_hg.c"


	return 0;
}
int cas_ctl_pos_i_g		  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
     /* oblique */
     #include"ccpo_dh.c"
     #include"ccpo_db.c"
     #include"ccpo_gb.c"
     #include"ccpo_gh.c"
     /* droite */
     #include"ccpd_h.c"
     #include"ccpd_d.c"
	 #include"ccpd_b.c"
     #include"ccpd_g.c"

     /* cavalier 		*/
	 #include"ccpc_hd.c"
     #include"ccpc_dh.c"
     #include"ccpc_db.c"
     #include"ccpc_bd.c"
     #include"ccpc_bg.c"
	 #include"ccpc_hg.c"

     /* pion   			*/
     #include"ccpp_d.c"
     #include"ccpp_g.c"

     /* roi  		*/
	 #include"ccpr_h.c"
	 #include"ccpr_hd.c"
     #include"ccpr_d.c"
     #include"ccpr_bd.c"
	 #include"ccpr_b.c"
     #include"ccpr_bg.c"
     #include"ccpr_g.c"
     #include"ccpr_hg.c"


	return 0;
}

/* case normale */
int cas_ctl_pos_nor		  (int xx, int yy)
{
	 int i_cam_adv;
	 int x,y;
	 int i_cam_pie;
	 char c_typ_pie;

	 i_cam_adv	=pts_hst_pro->i_cam_adv;

     /* tour fou reine 	*/
	 /* oblique */
	 #include"ccpo_dh.c"
     #include"ccpo_db.c"
     #include"ccpo_gb.c"
     #include"ccpo_gh.c"
     /* droite */
     #include"ccpd_h.c"
     #include"ccpd_d.c"
     #include"ccpd_b.c"
     #include"ccpd_g.c"

     /* cavalier 		*/
     #include"ccpc_hd.c"
     #include"ccpc_dh.c"
     #include"ccpc_db.c"
     #include"ccpc_bd.c"
     #include"ccpc_bg.c"
	 #include"ccpc_gb.c"
     #include"ccpc_gh.c"
     #include"ccpc_hg.c"

	 /* pion   			*/
     #include"ccpp_d.c"
     #include"ccpp_g.c"

     /* roi  		*/
	 #include"ccpr_h.c"
     #include"ccpr_hd.c"
     #include"ccpr_d.c"
     #include"ccpr_bd.c"
     #include"ccpr_b.c"
     #include"ccpr_bg.c"
     #include"ccpr_g.c"
     #include"ccpr_hg.c"

	  return 0;
}


/* fct  case sous controle adversaire     */
/* oblique: fou et reine */
int cas_ctl_h_d     (int x,int y,int i_cam_adv)
{

	 int i_cam_pie;
	 char c_typ_pie;

	 while(1)
	 {
	 	x++;y++;
	 	i_cam_pie = ts_ech[x][y].i_cam;

	 	if(i_cam_pie == i_cam_adv)				/* pice adverse */
	 	{
	 		c_typ_pie = (tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie;

	 		if(c_typ_pie == 'F'||c_typ_pie == 'D')   	/* renne ou fou */
				return 1;

	 		else                 /* piece averse ne pouvant provoquer echec */
	 			return 0;
		}
	    else       					/* piece propre camp ou hors limite */
	    {
	    	if (i_cam_pie != -1)
	    	return 0;
	    }

	 }

}
int cas_ctl_h_g     (int x,int y,int i_cam_adv)
{
	 int i_cam_pie;
	 char c_typ_pie;

	 while(1)
	 {
	 	x--;y++;
	 	i_cam_pie = ts_ech[x][y].i_cam;

		if(i_cam_pie == i_cam_adv)				/* pice adverse */
	 	{
	 		c_typ_pie = (tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie;

	 		if(c_typ_pie == 'F'||c_typ_pie == 'D')   	/* renne ou fou */
	 			return 1;

	 		else                 /* piece averse ne pouvant provoquer echec */
	 			return 0;
	    }
	    else       					/* piece propre camp ou hors limite */
	    {
	    	if (i_cam_pie != -1)
	    	return 0;
	    }
	 }


}
int cas_ctl_b_d     (int x,int y,int i_cam_adv)
{
	 int i_cam_pie;
	 char c_typ_pie;

	 while(1)
	 {
	 	x++;y--;
	 	i_cam_pie = ts_ech[x][y].i_cam;

	 	if(i_cam_pie == i_cam_adv)				/* pice adverse */
	 	{
	 		c_typ_pie = (tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie;

	 		if(c_typ_pie == 'F'||c_typ_pie == 'D')   	/* renne ou fou */
	 			return 1;

	 		else                 /* piece averse ne pouvant provoquer echec */
	 			return 0;
	    }
	    else       					/* piece propre camp ou hors limite */
		{
	    	if (i_cam_pie != -1)
	    	return 0;
	    }
	 }

}
int cas_ctl_b_g     (int x,int y,int i_cam_adv)
{
	 int i_cam_pie;
	 char c_typ_pie;

	 while(1)
	 {
	 	x--;y--;
	 	i_cam_pie = ts_ech[x][y].i_cam;

	 	if(i_cam_pie == i_cam_adv)				/* pice adverse */
	 	{
	 		c_typ_pie = (tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie;

	 		if(c_typ_pie == 'F'||c_typ_pie == 'D')   	/* renne ou fou */
	 			return 1;

	 		else                 /* piece averse ne pouvant provoquer echec */
	 			return 0;
	    }
	    else       					/* piece propre camp ou hors limite */
	    {
	    	if (i_cam_pie != -1)
	    	return 0;
	    }

	 }


}
/* droite  tour et reine */
int cas_ctl_h     (int x,int y,int i_cam_adv)
{
	 int i_cam_pie;
	 char c_typ_pie;

	 while(1)
	 {
	 	y++;
	 	i_cam_pie = ts_ech[x][y].i_cam;

	 	if(i_cam_pie == i_cam_adv)				/* pice adverse */
	 	{
	 		c_typ_pie = (tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie;

	 		if(c_typ_pie == 'T'||c_typ_pie == 'D')   	/* renne ou fou */
	 			return 1;

	 		else                 /* piece averse ne pouvant provoquer echec */
	 			return 0;
	    }
	    else       					/* piece propre camp ou hors limite */
	    {
			if (i_cam_pie != -1)
	    	return 0;
	    }
	 }

}
int cas_ctl_b     (int x,int y,int i_cam_adv)
{
	 int i_cam_pie;
	 char c_typ_pie;

	 while(1)
	 {
	 	y--;
	 	i_cam_pie = ts_ech[x][y].i_cam;

	 	if(i_cam_pie == i_cam_adv)				/* pice adverse */
	 	{
	 		c_typ_pie = (tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie;

			if(c_typ_pie == 'T'||c_typ_pie == 'D')   	/* renne ou fou */
	 			return 1;

	 		else                 /* piece averse ne pouvant provoquer echec */
	 			return 0;
	    }
	    else       					/* piece propre camp ou hors limite */
	    {
	    	if (i_cam_pie != -1)
	    	return 0;
	    }

	 }

}
int cas_ctl_d     (int x,int y,int i_cam_adv)
{
	 int i_cam_pie;
	 char c_typ_pie;

	 while(1)
	 {
		x++;
		i_cam_pie = ts_ech[x][y].i_cam;

		if(i_cam_pie == i_cam_adv)				/* pice adverse */
		{
			c_typ_pie = (tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie;

			if(c_typ_pie == 'T'||c_typ_pie == 'D')   	/* renne ou fou */
				return 1;

			else                 /* piece averse ne pouvant provoquer echec */
				return 0;
		}
		else       					/* piece propre camp ou hors limite */
		{
			if (i_cam_pie != -1)
			return 0;
		}

	 }
}
int cas_ctl_g     (int x,int y,int i_cam_adv)
{
	 int i_cam_pie;
	 char c_typ_pie;

	 while(1)
	 {
	 	x--;
	 	i_cam_pie = ts_ech[x][y].i_cam;

	 	if(i_cam_pie == i_cam_adv)				/* pice adverse */
	 	{
	 		c_typ_pie = (tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie;

	 		if(c_typ_pie == 'T'||c_typ_pie == 'D')   	/* renne ou fou */
	 			return 1;

			else                 /* piece averse ne pouvant provoquer echec */
	 			return 0;
	    }
	    else       					/* piece propre camp ou hors limite */
	    {
	    	if (i_cam_pie != -1)
	    	return 0;
	    }

	 }
}
/* cavalier haut droit*/
int cas_ctl_cav_h_d     (int x,int y,int i_cam_adv)
{
 	x+=1;
 	y+=2;
 	if(ts_ech[x][y].i_cam== i_cam_adv)				/* pice adverse */
 	{
 		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie == 'C')/* cav */
 			return 1;
	}

    return 0;
}
/* cavalier droite haut*/
int cas_ctl_cav_d_h     (int x,int y,int i_cam_adv)
{
 	x+=2;
 	y+=1;
 	if(ts_ech[x][y].i_cam == i_cam_adv)				/* pice adverse */
 	{
 		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie == 'C')/* cav */
 			return 1;
    }

	return 0;
}
/* cavalier droite bas*/
int cas_ctl_cav_d_b     (int x,int y,int i_cam_adv)
{
	x+=2;
 	y-=1;
 	if(ts_ech[x][y].i_cam == i_cam_adv)				/* pice adverse */
 	{
		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie == 'C')/* cav*/
 			return 1;
    }

	return 0;

}
/* cavalier bas droite*/
int cas_ctl_cav_b_d     (int x,int y,int i_cam_adv)
{
	x+=1;
	y-=2;
    if(ts_ech[x][y].i_cam== i_cam_adv)				/* pice adverse */
 	{
 		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie == 'C')/* cav  */
 			return 1;
	}

	return 0;
}
/* cavalier bas gauche */
int cas_ctl_cav_b_g     (int x,int y,int i_cam_adv)
{
 	x-=1;
 	y-=2;
 	if(ts_ech[x][y].i_cam == i_cam_adv)				/* pice adverse */
 	{
 		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie == 'C')/* cav */
 			return 1;
    }

	return 0;
}
/* cavalier gauche bas*/
int cas_ctl_cav_g_b     (int x,int y,int i_cam_adv)
{
	x-=2;
 	y-=1;
 	if(ts_ech[x][y].i_cam == i_cam_adv)				/* pice adverse */
 	{
 		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie == 'C')/* cav*/
 			return 1;
    }

	return 0;
}
/* cavalier gauche haut*/
int cas_ctl_cav_g_h     (int x,int y,int i_cam_adv)
{
 	x-=2;
 	y+=1;

 	if(ts_ech[x][y].i_cam == i_cam_adv)				/* pice adverse */
 	{
 		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie == 'C')/* cav*/
 			return 1;
	}

	return 0;
}
/* cavalier haut gauche*/
int cas_ctl_cav_h_g     (int x,int y,int i_cam_adv)
{
 	x-=1;
 	y+=2;

 	if(ts_ech[x][y].i_cam == i_cam_adv)				/* pice adverse */
 	{
 		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie == 'C')/* cav */
 			return 1;
    }

	return 0;

}
/* pion droit */
int cas_ctl_pio_d     (int x,int y,int i_cam_adv)
{
	 int i_cam_pie;
     x+=1;

     if (i_cam_adv ==1) 		y+=1;
	 /* camp adverse = 0 */
	 else 						y-=1;


 	i_cam_pie = ts_ech[x][y].i_cam;

 	if(i_cam_pie == i_cam_adv)				/* pice adverse */
 	{
 		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie== 'P')/* pion*/
 			return 1;
    }
    return 0;
}

/* pion gauche */
int cas_ctl_pio_g     (int x,int y,int i_cam_adv)
{
    int i_cam_pie;
    x-=1;

    if (i_cam_adv ==1)				y+=1;
    /* camp adverse = 0 */
    else							y-=1;

    i_cam_pie = ts_ech[x][y].i_cam;
 	if(i_cam_pie == i_cam_adv)				/* pice adverse */
 	{

 		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie== 'P')/* pion */
 			return 1;
    }
  	return 0;
}

/* roi haut */
int cas_ctl_roi_h     (int x,int y,int i_cam_adv)
{
 	y+=1;

 	if(ts_ech[x][y].i_cam == i_cam_adv)				/* pice adverse */
 	{
 		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie == 'R')   	/* roi  */
 			return 1;
    }
	return 0;
}
/* roi haut droit  */
int cas_ctl_roi_h_d     (int x,int y,int i_cam_adv)
{
 	y+=1;
 	x+=1;

 	if(ts_ech[x][y].i_cam == i_cam_adv)				/* pice adverse */
 	{
		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie == 'R')   	/* roi  */
 			return 1;
    }
	return 0;
}
/* roi droit  */
int cas_ctl_roi_d     (int x,int y,int i_cam_adv)
{
 	x+=1;

 	if(ts_ech[x][y].i_cam == i_cam_adv)				/* pice adverse */
 	{
 		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie == 'R')   	/* roi  */
 			return 1;
    }
	return 0;
}
/* roi bas droit  */
int cas_ctl_roi_b_d     (int x,int y,int i_cam_adv)
{
	x+=1;
 	y-=1;

 	if(ts_ech[x][y].i_cam == i_cam_adv)				/* pice adverse */
 	{
 		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie == 'R')   	/* roi  */
 			return 1;
    }
	return 0;
}
/* roi bas  */
int cas_ctl_roi_b    (int x,int y,int i_cam_adv)
{
 	y-=1;

 	if(ts_ech[x][y].i_cam == i_cam_adv)				/* pice adverse */
 	{
 		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie == 'R')   	/* roi  */
 			return 1;
    }
	return 0;
}
/* roi bas gauche  */
int cas_ctl_roi_b_g     (int x,int y,int i_cam_adv)
{
 	x-=1;
 	y-=1;

 	if(ts_ech[x][y].i_cam == i_cam_adv)				/* pice adverse */
 	{
 		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie == 'R')   	/* roi  */
 			return 1;
    }
	return 0;
}
/* roi gauche  */
int cas_ctl_roi_g     (int x,int y,int i_cam_adv)
{
 	x-=1;

	if(ts_ech[x][y].i_cam == i_cam_adv)				/* pice adverse */
 	{
 		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie == 'R')   	/* roi  */
 			return 1;
    }
	return 0;
}
/* roi gauche  */
int cas_ctl_roi_h_g     (int x,int y,int i_cam_adv)
{
 	x-=1;
 	y+=1;

 	if(ts_ech[x][y].i_cam == i_cam_adv)				/* pice adverse */
 	{
 		if((tpts_pie[i_cam_adv] +ts_ech[x][y].i_Id)->c_typ_pie == 'R')   	/* roi  */
 			return 1;
    }
	return 0;
}
