/*   
    
    Ec  Vers  29.0    Copyright (C)   2001 Marc Dechico

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/

#include "ec_data.h"
/*****************************************************************************/
/*  Initialisation tableau et variable 					                     */
/*****************************************************************************/
/* initialisation du camp  historique */
int ini_hst_cam (int i_cam_hst_0)
{
	int pro;

	switch (i_cam_hst_0)
	{
		case 0:
			ts_hst_pro[0].i_cam 		= 0;
			ts_hst_pro[0].i_cam_adv 	= 1;
			break;
		case 1:
			ts_hst_pro[0].i_cam 		= 1;
			ts_hst_pro[0].i_cam_adv 	= 0;
			break;
		default:
			return 1;
	}

	for (pro=1;pro<100;pro++)
	{
		ts_hst_pro[pro].i_cam 		= ts_hst_pro[pro-1].i_cam_adv;
		ts_hst_pro[pro].i_cam_adv 	= ts_hst_pro[pro-1].i_cam;
	}
	return 0;
}
/*Initialisation tableau et variable */
void ini_pgm (void)
{

	int x,y;
	int err;

	/* tableau correspondance posx <-> libelle colonne */
	tc_lib_col[0] =' ';
	tc_lib_col[1] =' ';
	tc_lib_col[2] ='A';
	tc_lib_col[3] ='B';
	tc_lib_col[4] ='C';
	tc_lib_col[5] ='D';
	tc_lib_col[6] ='E';
	tc_lib_col[7] ='F';
	tc_lib_col[8] ='G';
	tc_lib_col[9] ='H';
	tc_lib_col[10]=' ';
	tc_lib_col[11]=' ';

	/* tableau ptr fonction controle roi echec */
	pf_cas_ctl_pos[ 2][ 9]= cas_ctl_pos_c_h_g	  ;
	pf_cas_ctl_pos[ 9][ 9]= cas_ctl_pos_c_h_d	  ;
	pf_cas_ctl_pos[ 9][ 2]= cas_ctl_pos_c_b_d	  ;
	pf_cas_ctl_pos[ 2][ 2]= cas_ctl_pos_c_b_g	  ;

	pf_cas_ctl_pos[ 3][ 9]= cas_ctl_pos_h_g		  ;
	pf_cas_ctl_pos[ 8][ 9]= cas_ctl_pos_h_d		  ;
	pf_cas_ctl_pos[ 9][ 8]= cas_ctl_pos_d_h		  ;
	pf_cas_ctl_pos[ 9][ 3]= cas_ctl_pos_d_b		  ;
	pf_cas_ctl_pos[ 8][ 2]= cas_ctl_pos_b_d		  ;
	pf_cas_ctl_pos[ 3][ 2]= cas_ctl_pos_b_g		  ;
	pf_cas_ctl_pos[ 2][ 3]= cas_ctl_pos_g_b		  ;
	pf_cas_ctl_pos[ 2][ 8]= cas_ctl_pos_g_h		  ;

	for (x=4;x<=7;x++)
		pf_cas_ctl_pos[ x][ 9]= cas_ctl_pos_h		  ;

	for (y=4;y<=7;y++)
	{
		pf_cas_ctl_pos[ 9][ y]= cas_ctl_pos_d		  ;
	}
	for (x=4;x<=7;x++)
	{
		pf_cas_ctl_pos[ x][ 2]= cas_ctl_pos_b		  ;
	}
	for (y=4;y<=7;y++)
	{
		pf_cas_ctl_pos[ 2][ y]= cas_ctl_pos_g		  ;
	}

	/* case interieur */
	pf_cas_ctl_pos[ 3][ 8]= cas_ctl_pos_i_c_h_g	  ;
	pf_cas_ctl_pos[ 8][ 8]= cas_ctl_pos_i_c_h_d	  ;
	pf_cas_ctl_pos[ 8][ 3]= cas_ctl_pos_i_c_b_d	  ;
	pf_cas_ctl_pos[ 3][ 3]= cas_ctl_pos_i_c_b_g	  ;

	for (x=4;x<=7;x++)
	{
		pf_cas_ctl_pos[ x][ 8]= cas_ctl_pos_i_h		  ;
	}
	for (y=4;y<=7;y++)
	{
		pf_cas_ctl_pos[ 8][ y]= cas_ctl_pos_i_d		  ;
	}
	for (x=4;x<=7;x++)
	{
		pf_cas_ctl_pos[ x][ 3]= cas_ctl_pos_i_b		  ;
	}
	for (y=4;y<=7;y++)
	{
		pf_cas_ctl_pos[ 3][ y]= cas_ctl_pos_i_g		  ;
	}

	/* case normale */
	for (x=4;x<=7;x++)
	{
		for (y=4;y<=7;y++)
		{
			pf_cas_ctl_pos[ x][ y]= cas_ctl_pos_nor		  ;
		}
	}

 /* initialisation ptr tbl ptr mvt selon position */
	 /* case exterieur */
	 ptpf_mvt_roi[2][2]= tpf_roi_b_g;
	 ptpf_mvt_roi[9][2]= tpf_roi_b_d;
	 ptpf_mvt_roi[2][9]= tpf_roi_h_g;
	 ptpf_mvt_roi[9][9]= tpf_roi_h_d;

	 for (y=3;y<=8;y++)
	 {
		 ptpf_mvt_roi[2][y]= tpf_roi_g;
	 }
	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_roi[x][9]= tpf_roi_h;
	 }
	 ptpf_mvt_roi[6][9]= tpf_roi_pos_ori_1;	/* pour gestion du rock */

	 for (y=3;y<=8;y++)
	 {
		 ptpf_mvt_roi[9][y]= tpf_roi_d;
	 }
	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_roi[x][2]= tpf_roi_b;
	 }
	 ptpf_mvt_roi[6][2]= tpf_roi_pos_ori_0; /* pour gestion du rock */

	 /* centre */
	 for (x=3;x<=8;x++)
	 {
		 for (y=3;y<=8;y++)
		 {
			 ptpf_mvt_roi[x][y]= tpf_roi_nor;
		 }
	 }
/* intialisation ptr fonction  suivant position roi */
	 /* roi haut gauche */
	 tpf_roi_h_g[0] = droite_R;
	 tpf_roi_h_g[1] = bas_droite_R;
	 tpf_roi_h_g[2] = bas_R;
	 tpf_roi_h_g[3] = pie_sui;

	 /* roi haut */
	 tpf_roi_h[0] = droite_R;
	 tpf_roi_h[1] = bas_droite_R;
	 tpf_roi_h[2] = bas_R;
	 tpf_roi_h[3] = bas_gauche_R;
	 tpf_roi_h[4] = gauche_R;
	 tpf_roi_h[5] = pie_sui;

	 /* roi pos origine noir */
	 tpf_roi_pos_ori_1[0] = droite_R;
	 tpf_roi_pos_ori_1[1] = bas_droite_R;
	 tpf_roi_pos_ori_1[2] = bas_R;
	 tpf_roi_pos_ori_1[3] = bas_gauche_R;
	 tpf_roi_pos_ori_1[4] = gauche_R;
	 tpf_roi_pos_ori_1[5] = grd_roc_1;
	 tpf_roi_pos_ori_1[6] = pet_roc_1;
	 tpf_roi_pos_ori_1[7] = pie_sui;

	 /* roi haut droite */
	 tpf_roi_h_d[0] = bas_R;
	 tpf_roi_h_d[1] = bas_gauche_R;
	 tpf_roi_h_d[2] = gauche_R;
	 tpf_roi_h_d[3] = pie_sui;

	 /* roi droite */
	 tpf_roi_d[0] = haut_R;
	 tpf_roi_d[1] = bas_R;
	 tpf_roi_d[2] = bas_gauche_R;
	 tpf_roi_d[3] = gauche_R;
	 tpf_roi_d[4] = haut_gauche_R;
	 tpf_roi_d[5] = pie_sui;

	 /* roi bas droite */
	 tpf_roi_b_d[0] = haut_R;
	 tpf_roi_b_d[1] = gauche_R;
	 tpf_roi_b_d[2] = haut_gauche_R;
	 tpf_roi_b_d[3] = pie_sui;

	 /* roi bas */
	 tpf_roi_b[0] = haut_R;
	 tpf_roi_b[1] = haut_droite_R;
	 tpf_roi_b[2] = droite_R;
	 tpf_roi_b[3] = gauche_R;
	 tpf_roi_b[4] = haut_gauche_R;
	 tpf_roi_b[5] = pie_sui;

	 /* roi pos origine blanc */
	 tpf_roi_pos_ori_0[0] = haut_R;
	 tpf_roi_pos_ori_0[1] = haut_droite_R;
	 tpf_roi_pos_ori_0[2] = droite_R;
	 tpf_roi_pos_ori_0[3] = gauche_R;
	 tpf_roi_pos_ori_0[4] = haut_gauche_R;
	 tpf_roi_pos_ori_0[5] = grd_roc_0;
	 tpf_roi_pos_ori_0[6] = pet_roc_0;
	 tpf_roi_pos_ori_0[7] = pie_sui;

	 /* roi bas gauche */
	 tpf_roi_b_g[0] = haut_R;
	 tpf_roi_b_g[1] = haut_droite_R;
	 tpf_roi_b_g[2] = droite_R;
	 tpf_roi_b_g[3] = pie_sui;

	 /* roi gauche */
	 tpf_roi_g[0] = haut_R;
	 tpf_roi_g[1] = haut_droite_R;
	 tpf_roi_g[2] = droite_R;
	 tpf_roi_g[3] = bas_droite_R;
	 tpf_roi_g[4] = bas_R;
	 tpf_roi_g[5] = pie_sui;

	 /* roi normal */
	 tpf_roi_nor[0] = haut_R;
	 tpf_roi_nor[1] = haut_droite_R;
	 tpf_roi_nor[2] = droite_R;
	 tpf_roi_nor[3] = bas_droite_R;
	 tpf_roi_nor[4] = bas_R;
	 tpf_roi_nor[5] = bas_gauche_R;
	 tpf_roi_nor[6] = gauche_R;
	 tpf_roi_nor[7] = haut_gauche_R;
	 tpf_roi_nor[8] = pie_sui;

	/* initialisation ptr tbl ptr  reine selon position */
	 /* case exterieur */
	 ptpf_mvt_rei[2][2]= tpf_rei_b_g;
	 ptpf_mvt_rei[2][9]= tpf_rei_h_g;
	 ptpf_mvt_rei[9][9]= tpf_rei_h_d;
	 ptpf_mvt_rei[9][2]= tpf_rei_b_d;

	 for (y=3;y<=8;y++)
	 {
		 ptpf_mvt_rei[2][y]= tpf_rei_g;
	 }
	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_rei[x][9]= tpf_rei_h;
	 }
	 for (y=3;y<=8;y++)
	 {
		 ptpf_mvt_rei[9][y]= tpf_rei_d;
	 }
	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_rei[x][2]= tpf_rei_b;
	 }

	 /* centre */
	 for (x=3;x<=8;x++)
	 {
		 for (y=3;y<=8;y++)
		 {
			 ptpf_mvt_rei[x][y]= tpf_rei_nor;
		 }
	 }
/* intialisation ptr fonction suivant position reine */
	 /* reine haut gauche */
	 tpf_rei_h_g[0] = droite;
	 tpf_rei_h_g[1] = bas_droite;
	 tpf_rei_h_g[2] = bas;
	 tpf_rei_h_g[3] = pie_sui;

	 /* reine haut */
	 tpf_rei_h[0] = droite;
	 tpf_rei_h[1] = bas_droite;
	 tpf_rei_h[2] = bas;
	 tpf_rei_h[3] = bas_gauche;
	 tpf_rei_h[4] = gauche;
	 tpf_rei_h[5] = pie_sui;

	 /* reine haut droite */
	 tpf_rei_h_d[0] = bas;
	 tpf_rei_h_d[1] = bas_gauche;
	 tpf_rei_h_d[2] = gauche;
	 tpf_rei_h_d[3] = pie_sui;

	 /* reine droite */
	 tpf_rei_d[0] = haut;
	 tpf_rei_d[1] = bas;
	 tpf_rei_d[2] = bas_gauche;
	 tpf_rei_d[3] = gauche;
	 tpf_rei_d[4] = haut_gauche;
	 tpf_rei_d[5] = pie_sui;

	 /* reine bas droite */
	 tpf_rei_b_d[0] = haut;
	 tpf_rei_b_d[1] = gauche;
	 tpf_rei_b_d[2] = haut_gauche;
	 tpf_rei_b_d[3] = pie_sui;

	 /* reine bas */
	 tpf_rei_b[0] = haut;
	 tpf_rei_b[1] = haut_droite;
	 tpf_rei_b[2] = droite;
	 tpf_rei_b[3] = gauche;
	 tpf_rei_b[4] = haut_gauche;
	 tpf_rei_b[5] = pie_sui;

	 /* reine bas gauche */
	 tpf_rei_b_g[0] = haut;
	 tpf_rei_b_g[1] = haut_droite;
	 tpf_rei_b_g[2] = droite;
	 tpf_rei_b_g[3] = pie_sui;

	 /* reine gauche */
	 tpf_rei_g[0] = haut;
	 tpf_rei_g[1] = haut_droite;
	 tpf_rei_g[2] = droite;
	 tpf_rei_g[3] = bas_droite;
	 tpf_rei_g[4] = bas;
	 tpf_rei_g[5] = pie_sui;

	 /* reine normal */
	 tpf_rei_nor[0] = haut;
	 tpf_rei_nor[1] = haut_droite;
	 tpf_rei_nor[2] = droite;
	 tpf_rei_nor[3] = bas_droite;
	 tpf_rei_nor[4] = bas;
	 tpf_rei_nor[5] = bas_gauche;
	 tpf_rei_nor[6] = gauche;
	 tpf_rei_nor[7] = haut_gauche;
	 tpf_rei_nor[8] = pie_sui;

	/* initialisation ptr tbl ptr fou selon position */
	 /* case exterieur */
	 ptpf_mvt_fou[2][2]= tpf_fou_b_g;
	 ptpf_mvt_fou[2][9]= tpf_fou_h_g;
	 ptpf_mvt_fou[9][9]= tpf_fou_h_d;
	 ptpf_mvt_fou[9][2]= tpf_fou_b_d;

	 for (y=3;y<=8;y++)
	 {
		 ptpf_mvt_fou[2][y]= tpf_fou_g;
	 }
	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_fou[x][9]= tpf_fou_h;
	 }
	 for (y=3;y<=8;y++)
	 {
		 ptpf_mvt_fou[9][y]= tpf_fou_d;
	 }
	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_fou[x][2]= tpf_fou_b;
	 }

	 /* centre */
	 for (x=3;x<=8;x++)
	 {
		 for (y=3;y<=8;y++)
		 {
			 ptpf_mvt_fou[x][y]= tpf_fou_nor;
		 }
	 }
/* intialisation ptr fonction suivant position fou */
	 /* fou haut gauche */
	 tpf_fou_h_g[0] = bas_droite;
	 tpf_fou_h_g[1] = pie_sui;

	 /* fou haut */
	 tpf_fou_h[0] = bas_droite;
	 tpf_fou_h[1] = bas_gauche;
	 tpf_fou_h[2] = pie_sui;

	 /* fou haut droite */
	 tpf_fou_h_d[0] = bas_gauche;
	 tpf_fou_h_d[1] = pie_sui;

	 /* fou droite */
	 tpf_fou_d[0] = bas_gauche;
	 tpf_fou_d[1] = haut_gauche;
	 tpf_fou_d[2] = pie_sui;

	 /* fou bas droite */
	 tpf_fou_b_d[0] = haut_gauche;
	 tpf_fou_b_d[1] = pie_sui;

	 /* fou bas */
	 tpf_fou_b[0] = haut_droite;
	 tpf_fou_b[1] = haut_gauche;
	 tpf_fou_b[2] = pie_sui;

	 /* fou bas gauche */
	 tpf_fou_b_g[0] = haut_droite;
	 tpf_fou_b_g[1] = pie_sui;

	 /* fou gauche */
	 tpf_fou_g[0] = haut_droite;
	 tpf_fou_g[1] = bas_droite;
	 tpf_fou_g[2] = pie_sui;

	 /* fou normal */
	 tpf_fou_nor[0] = haut_droite;
	 tpf_fou_nor[1] = bas_droite;
	 tpf_fou_nor[2] = bas_gauche;
	 tpf_fou_nor[3] = haut_gauche;
	 tpf_fou_nor[4] = pie_sui;

	/* initialisation ptr tbl ptr et nbr dir reine selon position */
	 /* case exterieur */
	 ptpf_mvt_tou[2][2]= tpf_tou_b_g;
	 ptpf_mvt_tou[2][9]= tpf_tou_h_g;
	 ptpf_mvt_tou[9][9]= tpf_tou_h_d;
	 ptpf_mvt_tou[9][2]= tpf_tou_b_d;

	 for (y=3;y<=8;y++)
	 {
		 ptpf_mvt_tou[2][y]= tpf_tou_g;
	 }
	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_tou[x][9]= tpf_tou_h;
	 }
	 for (y=3;y<=8;y++)
	 {
		 ptpf_mvt_tou[9][y]= tpf_tou_d;
	 }
	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_tou[x][2]= tpf_tou_b;
	 }

	 /* centre */
	 for (x=3;x<=8;x++)
	 {
		 for (y=3;y<=8;y++)
		 {
			 ptpf_mvt_tou[x][y]= tpf_tou_nor;
		 }
	 }
/* intialisation ptr fonction suivant position tou */
	 /* tour haut gauche */
	 tpf_tou_h_g[0] = droite_tou_gr;
	 tpf_tou_h_g[1] = bas_tou_gr;
	 tpf_tou_h_g[2] = pie_sui;

	 /* tour haut */
	 tpf_tou_h[0] = droite;
	 tpf_tou_h[1] = bas;
	 tpf_tou_h[2] = gauche;
	 tpf_tou_h[3] = pie_sui;

	 /* tour haut droite */
	 tpf_tou_h_d[0] = bas_tou_pr;
	 tpf_tou_h_d[1] = gauche_tou_pr;
	 tpf_tou_h_d[2] = pie_sui;

	 /* tour droite */
	 tpf_tou_d[0] = haut;
	 tpf_tou_d[1] = bas;
	 tpf_tou_d[2] = gauche;
	 tpf_tou_d[3] = pie_sui;

	 /* tour bas droite */
	 tpf_tou_b_d[0] = haut_tou_pr;
	 tpf_tou_b_d[1] = gauche_tou_pr;
	 tpf_tou_b_d[2] = pie_sui;

	 /* tour bas */
	 tpf_tou_b[0] = haut;
	 tpf_tou_b[1] = droite;
	 tpf_tou_b[2] = gauche;
	 tpf_tou_b[3] = pie_sui;

	 /* tour bas gauche */
	 tpf_tou_b_g[0] = haut_tou_gr;
	 tpf_tou_b_g[1] = droite_tou_gr;
	 tpf_tou_b_g[2] = pie_sui;

	 /* tour gauche */
	 tpf_tou_g[0] = haut;
	 tpf_tou_g[1] = droite;
	 tpf_tou_g[2] = bas;
	 tpf_tou_g[3] = pie_sui;

	 /* tour normal */
	 tpf_tou_nor[0] = haut;
	 tpf_tou_nor[1] = droite;
	 tpf_tou_nor[2] = bas;
	 tpf_tou_nor[3] = gauche;
	 tpf_tou_nor[4] = pie_sui;


	/* initialisation ptr tbl ptr et nbr dir cavalier selon position */
	 /* case exterieur */
	 ptpf_mvt_cav[2][2]= tpf_cav_c_b_g;
	 ptpf_mvt_cav[9][2]= tpf_cav_c_b_d;
	 ptpf_mvt_cav[2][9]= tpf_cav_c_h_g;
	 ptpf_mvt_cav[9][9]= tpf_cav_c_h_d;
	 ptpf_mvt_cav[2][3]= tpf_cav_g_b;
	 ptpf_mvt_cav[2][8]= tpf_cav_g_h;
	 ptpf_mvt_cav[3][9]= tpf_cav_h_g;
	 ptpf_mvt_cav[8][9]= tpf_cav_h_d;
	 ptpf_mvt_cav[9][8]= tpf_cav_d_h;
	 ptpf_mvt_cav[9][3]= tpf_cav_d_b;
	 ptpf_mvt_cav[8][2]= tpf_cav_b_d;
	 ptpf_mvt_cav[3][2]= tpf_cav_b_g;
	 for (y=4;y<=7;y++)
	 {
		 ptpf_mvt_cav[2][y]= tpf_cav_g;
	 }
	 for (x=4;x<=7;x++)
	 {
		 ptpf_mvt_cav[x][9]= tpf_cav_h;
	 }
	 for (y=4;y<=7;y++)
	 {
		 ptpf_mvt_cav[9][y]= tpf_cav_d;
	 }
	 for (x=4;x<=7;x++)
	 {
		 ptpf_mvt_cav[x][2]= tpf_cav_b;
	 }

	 /* case interieur */
	 ptpf_mvt_cav[3][3]= tpf_cav_i_c_b_g;
	 ptpf_mvt_cav[3][8]= tpf_cav_i_c_h_g;
	 ptpf_mvt_cav[8][8]= tpf_cav_i_c_h_d;
	 ptpf_mvt_cav[8][3]= tpf_cav_i_c_b_d;

	 for (y=4;y<=7;y++)
	 {
		 ptpf_mvt_cav[3][y]= tpf_cav_i_g;
	 }
	 for (x=4;x<=7;x++)
	 {
		 ptpf_mvt_cav[x][8]= tpf_cav_i_h;
	 }
	 for (y=4;y<=7;y++)
	 {
		 ptpf_mvt_cav[8][y]= tpf_cav_i_d;
	 }
	 for (x=4;x<=7;x++)
	 {
		 ptpf_mvt_cav[x][3]= tpf_cav_i_b;
	 }
	 /* centre */
	 for (x=4;x<=7;x++)
	 {
		 for (y=4;y<=7;y++)
		 {
			 ptpf_mvt_cav[x][y]= tpf_cav_nor;
		 }
	 }


/* intialisation ptr fonction suivant position cavalier */
	 /* cavalier coin haut gauche */
	 tpf_cav_c_h_g[0] = droite_bas_C;
	 tpf_cav_c_h_g[1] = bas_droite_C;
	 tpf_cav_c_h_g[2] = pie_sui;

	 /* cavalier  haut gauche */
	 tpf_cav_h_g[0] = droite_bas_C;
	 tpf_cav_h_g[1] = bas_droite_C;
	 tpf_cav_h_g[2] = bas_gauche_C;
	 tpf_cav_h_g[3] = pie_sui;

	 /* cavalier haut */
	 tpf_cav_h[0] = droite_bas_C;
	 tpf_cav_h[1] = bas_droite_C;
	 tpf_cav_h[2] = bas_gauche_C;
	 tpf_cav_h[3] = gauche_bas_C;
	 tpf_cav_h[4] = pie_sui;

	 /* cavalier haut droit */
	 tpf_cav_h_d[0] = bas_droite_C;
	 tpf_cav_h_d[1] = bas_gauche_C;
	 tpf_cav_h_d[2] = gauche_bas_C;
     tpf_cav_h_d[3] = pie_sui;

	 /* cavalier coin haut droit */
	 tpf_cav_c_h_d[0] = bas_gauche_C;
     tpf_cav_c_h_d[1] = gauche_bas_C;
	 tpf_cav_c_h_d[2] = pie_sui;

	 /* cavalier droite haut */
	 tpf_cav_d_h[0] = bas_gauche_C;
	 tpf_cav_d_h[1] = gauche_bas_C;
	 tpf_cav_d_h[2] = gauche_haut_C;
	 tpf_cav_d_h[3] = pie_sui;

	 /* cavalier droite */
	 tpf_cav_d[0] = bas_gauche_C;
	 tpf_cav_d[1] = gauche_bas_C;
	 tpf_cav_d[2] = gauche_haut_C;
	 tpf_cav_d[3] = haut_gauche_C;
	 tpf_cav_d[4] = pie_sui;

	 /* cavalier droite bas */
	 tpf_cav_d_b[0] = gauche_bas_C;
	 tpf_cav_d_b[1] = gauche_haut_C;
	 tpf_cav_d_b[2] = haut_gauche_C;
	 tpf_cav_d_b[3] = pie_sui;

	 /* cavalier coin bas droite */
	 tpf_cav_c_b_d[0] = gauche_haut_C;
	 tpf_cav_c_b_d[1] = haut_gauche_C;
	 tpf_cav_c_b_d[2] = pie_sui;

	 /* cavalier bas droite */
	 tpf_cav_b_d[0] = haut_droite_C;
	 tpf_cav_b_d[1] = gauche_haut_C;
	 tpf_cav_b_d[2] = haut_gauche_C;
	 tpf_cav_b_d[3] = pie_sui;

	 /* cavalier bas */
	 tpf_cav_b[0] = haut_droite_C;
	 tpf_cav_b[1] = droite_haut_C;
	 tpf_cav_b[2] = gauche_haut_C;
	 tpf_cav_b[3] = haut_gauche_C;
	 tpf_cav_b[4] = pie_sui;

	 /* cavalier bas gauche */
	 tpf_cav_b_g[0] = haut_droite_C;
	 tpf_cav_b_g[1] = droite_haut_C;
	 tpf_cav_b_g[2] = haut_gauche_C;
	 tpf_cav_b_g[3] = pie_sui;

	 /* cavalier coin bas gauche */
	 tpf_cav_c_b_g[0] = haut_droite_C;
	 tpf_cav_c_b_g[1] = droite_haut_C;
	 tpf_cav_c_b_g[2] = pie_sui;

	 /* cavalier gauche bas */
	 tpf_cav_g_b[0] = haut_droite_C;
	 tpf_cav_g_b[1] = droite_haut_C;
	 tpf_cav_g_b[2] = droite_bas_C;
	 tpf_cav_g_b[3] = pie_sui;

	 /* cavalier gauche */
	 tpf_cav_g[0] = haut_droite_C;
	 tpf_cav_g[1] = droite_haut_C;
	 tpf_cav_g[2] = droite_bas_C;
	 tpf_cav_g[3] = bas_droite_C;
	 tpf_cav_g[4] = pie_sui;

	 /* cavalier gauche haut */
	 tpf_cav_g_h[0] = droite_haut_C;
	 tpf_cav_g_h[1] = droite_bas_C;
	 tpf_cav_g_h[2] = bas_droite_C;
	 tpf_cav_g_h[3] = pie_sui;

	 /* cavalier interne coin haut gauche */
	 tpf_cav_i_c_h_g[0] = droite_haut_C;
	 tpf_cav_i_c_h_g[1] = droite_bas_C;
	 tpf_cav_i_c_h_g[2] = bas_droite_C;
	 tpf_cav_i_c_h_g[3] = bas_gauche_C;
	 tpf_cav_i_c_h_g[4] = pie_sui;

	 /* cavalier interne haut */
	 tpf_cav_i_h[0] = droite_haut_C;
	 tpf_cav_i_h[1] = droite_bas_C;
	 tpf_cav_i_h[2] = bas_droite_C;
	 tpf_cav_i_h[3] = bas_gauche_C;
	 tpf_cav_i_h[4] = gauche_bas_C;
	 tpf_cav_i_h[5] = gauche_haut_C;
	 tpf_cav_i_h[6] = pie_sui;

	 /* cavalier interne coin haut droit */
	 tpf_cav_i_c_h_d[0] = bas_droite_C;
	 tpf_cav_i_c_h_d[1] = bas_gauche_C;
	 tpf_cav_i_c_h_d[2] = gauche_bas_C;
	 tpf_cav_i_c_h_d[3] = gauche_haut_C;
	 tpf_cav_i_c_h_d[4] = pie_sui;

	 /* cavalier interne droit */
	 tpf_cav_i_d[0] = haut_droite_C;
	 tpf_cav_i_d[1] = bas_droite_C;
	 tpf_cav_i_d[2] = bas_gauche_C;
	 tpf_cav_i_d[3] = gauche_bas_C;
	 tpf_cav_i_d[4] = gauche_haut_C;
	 tpf_cav_i_d[5] = haut_gauche_C;
	 tpf_cav_i_d[6] = pie_sui;

	 /* cavalier interne coin bas droite */
	 tpf_cav_i_c_b_d[0] = haut_droite_C;
	 tpf_cav_i_c_b_d[1] = gauche_bas_C;
	 tpf_cav_i_c_b_d[2] = gauche_haut_C;
	 tpf_cav_i_c_b_d[3] = haut_gauche_C;
	 tpf_cav_i_c_b_d[4] = pie_sui;

	 /* cavalier interne bas */
	 tpf_cav_i_b[0] = haut_droite_C;
	 tpf_cav_i_b[1] = droite_haut_C;
	 tpf_cav_i_b[2] = droite_bas_C;
	 tpf_cav_i_b[3] = gauche_bas_C;
	 tpf_cav_i_b[4] = gauche_haut_C;
	 tpf_cav_i_b[5] = haut_gauche_C;
	 tpf_cav_i_b[6] = pie_sui;

	 /* cavalier interne coin gauche bas */
	 tpf_cav_i_c_b_g[0] = haut_droite_C;
	 tpf_cav_i_c_b_g[1] = droite_haut_C;
	 tpf_cav_i_c_b_g[2] = droite_bas_C;
	 tpf_cav_i_c_b_g[3] = haut_gauche_C;
	 tpf_cav_i_c_b_g[4] = pie_sui;

	 /* cavalier interne gauche */
	 tpf_cav_i_g[0] = haut_droite_C;
	 tpf_cav_i_g[1] = droite_haut_C;
	 tpf_cav_i_g[2] = droite_bas_C;
	 tpf_cav_i_g[3] = bas_droite_C;
	 tpf_cav_i_g[4] = bas_gauche_C;
	 tpf_cav_i_g[5] = haut_gauche_C;
	 tpf_cav_i_g[6] = pie_sui;

	 /* cavalier normal */
	 tpf_cav_nor[0] = haut_droite_C;
	 tpf_cav_nor[1] = droite_haut_C;
	 tpf_cav_nor[2] = droite_bas_C;
	 tpf_cav_nor[3] = bas_droite_C;
	 tpf_cav_nor[4] = bas_gauche_C;
	 tpf_cav_nor[5] = gauche_bas_C;
	 tpf_cav_nor[6] = gauche_haut_C;
	 tpf_cav_nor[7] = haut_gauche_C;
	 tpf_cav_nor[8] = pie_sui;

/* initialisation ptr tbl ptr mvt selon position pour pion blanc */
	 /* ligne 1, 8 jammais occup par un piont blanc  */
		 for (x=2;x<=9;x++)
	 {
		 ptpf_mvt_pio_0[x][2]= NULL;
	 }
		 for (x=2;x<=9;x++)
	 {
		 ptpf_mvt_pio_0[x][9]= NULL;
	 }

	 /* ligne 2  */
	 ptpf_mvt_pio_0[2][3]= tpf_pio_0_L2_g;
	 ptpf_mvt_pio_0[9][3]= tpf_pio_0_L2_d;

	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_pio_0[x][3]= tpf_pio_0_L2;
	 }
	 /* ligne 3,4,6 */
	 ptpf_mvt_pio_0[2][4]= tpf_pio_0_L346_g;
	 ptpf_mvt_pio_0[9][4]= tpf_pio_0_L346_d;

	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_pio_0[x][4]= tpf_pio_0_L346;
	 }
	 ptpf_mvt_pio_0[2][5]= tpf_pio_0_L346_g;
	 ptpf_mvt_pio_0[9][5]= tpf_pio_0_L346_d;

	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_pio_0[x][5]= tpf_pio_0_L346;
	 }
	 ptpf_mvt_pio_0[2][7]= tpf_pio_0_L346_g;
	 ptpf_mvt_pio_0[9][7]= tpf_pio_0_L346_d;

	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_pio_0[x][7]= tpf_pio_0_L346;
	 }
	 /* ligne 5 */
	 ptpf_mvt_pio_0[2][6]= tpf_pio_0_L5_g;
	 ptpf_mvt_pio_0[9][6]= tpf_pio_0_L5_d;

	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_pio_0[x][6]= tpf_pio_0_L5;
	 }
	 /* ligne 7 */
	 ptpf_mvt_pio_0[2][8]= tpf_pio_0_L7_g;
	 ptpf_mvt_pio_0[9][8]= tpf_pio_0_L7_d;

	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_pio_0[x][8]= tpf_pio_0_L7;
	 }
/* intialisation ptr fonction  suivant position pion */
	 /* pion en ligne 2 gauche */
	 tpf_pio_0_L2_g[0] = haut_1_p_0;
	 tpf_pio_0_L2_g[1] = haut_2_p_0;
	 tpf_pio_0_L2_g[2] = haut_droite_p_0;
	 tpf_pio_0_L2_g[3] = pie_sui;

	 /* pion en ligne 2 milieu */
	 tpf_pio_0_L2[0] = haut_1_p_0;
	 tpf_pio_0_L2[1] = haut_2_p_0;
	 tpf_pio_0_L2[2] = haut_gauche_p_0;
	 tpf_pio_0_L2[3] = haut_droite_p_0;
	 tpf_pio_0_L2[4] = pie_sui;

	 /* pion en ligne 2 droite */
	 tpf_pio_0_L2_d[0] = haut_1_p_0;
	 tpf_pio_0_L2_d[1] = haut_2_p_0;
	 tpf_pio_0_L2_d[2] = haut_gauche_p_0;
	 tpf_pio_0_L2_d[3] = pie_sui;

	 /* pion en ligne 3,4,6 gauche */
	 tpf_pio_0_L346_g[0] = haut_1_p_0;
	 tpf_pio_0_L346_g[1] = haut_droite_p_0;
	 tpf_pio_0_L346_g[2] = pie_sui;

	 /* pion en ligne 3,4,6 milieu */
	 tpf_pio_0_L346[0] = haut_1_p_0;
	 tpf_pio_0_L346[1] = haut_gauche_p_0;
	 tpf_pio_0_L346[2] = haut_droite_p_0;
	 tpf_pio_0_L346[3] = pie_sui;

	 /* pion en ligne 3,4,6 droite */
	 tpf_pio_0_L346_d[0] = haut_1_p_0;
	 tpf_pio_0_L346_d[1] = haut_gauche_p_0;
	 tpf_pio_0_L346_d[2] = pie_sui;

	 /* pion en ligne 5 gauche */
	 tpf_pio_0_L5_g[0] = haut_1_p_0;
	 tpf_pio_0_L5_g[1] = haut_droite_p_0;
	 tpf_pio_0_L5_g[2] = haut_droite_pas_p_0;
	 tpf_pio_0_L5_g[3] = pie_sui;

	 /* pion en ligne 5 milieu */
	 tpf_pio_0_L5[0] = haut_1_p_0;
	 tpf_pio_0_L5[1] = haut_gauche_p_0;
	 tpf_pio_0_L5[2] = haut_droite_p_0;
	 tpf_pio_0_L5[3] = haut_gauche_pas_p_0;
	 tpf_pio_0_L5[4] = haut_droite_pas_p_0;
	 tpf_pio_0_L5[5] = pie_sui;

	 /* pion en ligne 5 droite */
	 tpf_pio_0_L5_d[0] = haut_1_p_0;
	 tpf_pio_0_L5_d[1] = haut_gauche_p_0;
	 tpf_pio_0_L5_d[2] = haut_gauche_pas_p_0;
	 tpf_pio_0_L5_d[3] = pie_sui;

	 /* conserver l'ordre des postes dans le tableau L7 */
	 /* car pice remis a position origine aprs piece suivante */
	 /* pion en ligne 7 gauche */
	 tpf_pio_0_L7_g[0] = haut_cav_p_0;
	 tpf_pio_0_L7_g[1] = haut_droite_cav_p_0;
	 tpf_pio_0_L7_g[2] = haut_rei_p_0;
	 tpf_pio_0_L7_g[3] = haut_droite_rei_p_0;
	 tpf_pio_0_L7_g[4] = pie_sui;

	 /* pion en ligne 7 milieu */
	 tpf_pio_0_L7[0] = haut_cav_p_0;
	 tpf_pio_0_L7[1] = haut_droite_cav_p_0;
	 tpf_pio_0_L7[2] = haut_gauche_cav_p_0;
	 tpf_pio_0_L7[3] = haut_rei_p_0;
	 tpf_pio_0_L7[4] = haut_droite_rei_p_0;
	 tpf_pio_0_L7[5] = haut_gauche_rei_p_0;
	 tpf_pio_0_L7[6] = pie_sui;

	 /* pion en ligne 7 droite */
	 tpf_pio_0_L7_d[0] = haut_cav_p_0;
	 tpf_pio_0_L7_d[1] = haut_gauche_cav_p_0;
	 tpf_pio_0_L7_d[2] = haut_rei_p_0;
	 tpf_pio_0_L7_d[3] = haut_gauche_rei_p_0;
	 tpf_pio_0_L7_d[4] = pie_sui;
/* initialisation ptr tbl ptr mvt selon position pour pion noir */
/* ligne 8, 1 jammais occup par un piont noir  */
		 for (x=2;x<=9;x++)
	 {
		 ptpf_mvt_pio_1[x][2]= NULL;
	 }
		 for (x=2;x<=9;x++)
	 {
		 ptpf_mvt_pio_1[x][9]= NULL;
	 }

	 /* ligne 7  */
	 ptpf_mvt_pio_1[2][8]= tpf_pio_1_L7_g;
	 ptpf_mvt_pio_1[9][8]= tpf_pio_1_L7_d;

	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_pio_1[x][8]= tpf_pio_1_L7;
	 }
	 /* ligne 6,5,3 */
	 ptpf_mvt_pio_1[2][7]= tpf_pio_1_L653_g;
	 ptpf_mvt_pio_1[9][7]= tpf_pio_1_L653_d;

	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_pio_1[x][7]= tpf_pio_1_L653;
	 }
	 ptpf_mvt_pio_1[2][6]= tpf_pio_1_L653_g;
	 ptpf_mvt_pio_1[9][6]= tpf_pio_1_L653_d;

	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_pio_1[x][6]= tpf_pio_1_L653;
	 }
	 ptpf_mvt_pio_1[2][4]= tpf_pio_1_L653_g;
	 ptpf_mvt_pio_1[9][4]= tpf_pio_1_L653_d;

	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_pio_1[x][4]= tpf_pio_1_L653;
	 }
	 /* ligne 4 */
	 ptpf_mvt_pio_1[2][5]= tpf_pio_1_L4_g;
	 ptpf_mvt_pio_1[9][5]= tpf_pio_1_L4_d;

	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_pio_1[x][5]= tpf_pio_1_L4;
	 }
	 /* ligne 2 */
	 ptpf_mvt_pio_1[2][3]= tpf_pio_1_L2_g;
	 ptpf_mvt_pio_1[9][3]= tpf_pio_1_L2_d;

	 for (x=3;x<=8;x++)
	 {
		 ptpf_mvt_pio_1[x][3]= tpf_pio_1_L2;
	 }
/* intialisation ptr fonction  suivant position pion */
	 /* pion en ligne 7 gauche */
	 tpf_pio_1_L7_g[0] = bas_1_p_1;
	 tpf_pio_1_L7_g[1] = bas_2_p_1;
	 tpf_pio_1_L7_g[2] = bas_droite_p_1;
	 tpf_pio_1_L7_g[3] = pie_sui;

	 /* pion en ligne 7 milieu */
	 tpf_pio_1_L7[0] = bas_1_p_1;
	 tpf_pio_1_L7[1] = bas_2_p_1;
	 tpf_pio_1_L7[2] = bas_gauche_p_1;
	 tpf_pio_1_L7[3] = bas_droite_p_1;
	 tpf_pio_1_L7[4] = pie_sui;

	 /* pion en ligne 7 droite */
	 tpf_pio_1_L7_d[0] = bas_1_p_1;
	 tpf_pio_1_L7_d[1] = bas_2_p_1;
	 tpf_pio_1_L7_d[2] = bas_gauche_p_1;
	 tpf_pio_1_L7_d[3] = pie_sui;

	 /* pion en ligne 6,5,3 gauche */
	 tpf_pio_1_L653_g[0] = bas_1_p_1;
	 tpf_pio_1_L653_g[1] = bas_droite_p_1;
	 tpf_pio_1_L653_g[2] = pie_sui;

	 /* pion en ligne 6,5,3 milieu */
	 tpf_pio_1_L653[0] = bas_1_p_1;
	 tpf_pio_1_L653[1] = bas_gauche_p_1;
	 tpf_pio_1_L653[2] = bas_droite_p_1;
	 tpf_pio_1_L653[3] = pie_sui;

	 /* pion en ligne 6,5,3 droite */
	 tpf_pio_1_L653_d[0] = bas_1_p_1;
	 tpf_pio_1_L653_d[1] = bas_gauche_p_1;
	 tpf_pio_1_L653_d[2] = pie_sui;

	 /* pion en ligne 4 gauche */
	 tpf_pio_1_L4_g[0] = bas_1_p_1;
	 tpf_pio_1_L4_g[1] = bas_droite_p_1;
	 tpf_pio_1_L4_g[2] = bas_droite_pas_p_1;
	 tpf_pio_1_L4_g[3] = pie_sui;

	 /* pion en ligne 4 milieu */
	 tpf_pio_1_L4[0] = bas_1_p_1;
	 tpf_pio_1_L4[1] = bas_gauche_p_1;
	 tpf_pio_1_L4[2] = bas_droite_p_1;
	 tpf_pio_1_L4[3] = bas_gauche_pas_p_1;
	 tpf_pio_1_L4[4] = bas_droite_pas_p_1;
	 tpf_pio_1_L4[5] = pie_sui;

	 /* pion en ligne 4 droite */
	 tpf_pio_1_L4_d[0] = bas_1_p_1;
	 tpf_pio_1_L4_d[1] = bas_gauche_p_1;
	 tpf_pio_1_L4_d[2] = bas_gauche_pas_p_1;
	 tpf_pio_1_L4_d[3] = pie_sui;

	 /* conserver l'ordre des postes dans le tableau L7 */
	 /* car pice remis a position origine aprs piece suivante */
	 /* pion en ligne 2 gauche */
	 tpf_pio_1_L2_g[0] = bas_cav_p_1;
	 tpf_pio_1_L2_g[1] = bas_droite_cav_p_1;
	 tpf_pio_1_L2_g[2] = bas_rei_p_1;
	 tpf_pio_1_L2_g[3] = bas_droite_rei_p_1;
	 tpf_pio_1_L2_g[4] = pie_sui;

	 /* pion en ligne 7 milieu */
	 tpf_pio_1_L2[0] = bas_cav_p_1;
	 tpf_pio_1_L2[1] = bas_droite_cav_p_1;
	 tpf_pio_1_L2[2] = bas_gauche_cav_p_1;
	 tpf_pio_1_L2[3] = bas_rei_p_1;
	 tpf_pio_1_L2[4] = bas_droite_rei_p_1;
	 tpf_pio_1_L2[5] = bas_gauche_rei_p_1;
	 tpf_pio_1_L2[6] = pie_sui;

	 /* pion en ligne 7 droite */
	 tpf_pio_1_L2_d[0] = bas_cav_p_1;
	 tpf_pio_1_L2_d[1] = bas_gauche_cav_p_1;
	 tpf_pio_1_L2_d[2] = bas_rei_p_1;
	 tpf_pio_1_L2_d[3] = bas_gauche_rei_p_1;
	 tpf_pio_1_L2_d[4] = pie_sui;

	/* tableau de ptr fonction restore echiquier */
	/*pour chaque type de mouvement  */
	/* pice principale */
	tpf_res_pie_pri[MVT_DEP_SIM]	= pie_pri_res; 	   /* deplacement simple*/
	tpf_res_pie_pri[MVT_PRI_SIM]	= pie_pri_res; 	   /* prise simple 	    */
	tpf_res_pie_pri[MVT_PIO_REI]	= pie_pri_res;
	tpf_res_pie_pri[MVT_PIO_TOU]	= pie_pri_res;
	tpf_res_pie_pri[MVT_PIO_FOU]	= pie_pri_res;
	tpf_res_pie_pri[MVT_PIO_CAV]	= pie_pri_res;
	tpf_res_pie_pri[MVT_PRI_PIO_REI]= NULL;
			/* bug ? */
	tpf_res_pie_pri[MVT_PRI_PIO_TOU]= NULL;
	tpf_res_pie_pri[MVT_PRI_PIO_FOU]= NULL;
	tpf_res_pie_pri[MVT_PRI_PIO_CAV]= NULL;
	tpf_res_pie_pri[MVT_PRI_PAS]	= pie_pri_res;     /* prise en passant  */
/*	tpf_res_pie_pri[MVT_PET_ROC] 	= roi_pet_roc_res;*/ /* petit rock  	    */
/*	tpf_res_pie_pri[MVT_GRA_ROC] 	= roi_grd_roc_res;*/ /* grand rock 	    */

	tpf_res_pie_pri[MVT_PET_ROC] 	= pie_pri_res; /* petit rock  	    */
	tpf_res_pie_pri[MVT_GRA_ROC] 	= pie_pri_res; /* grand rock 	    */

	/* piece secondaire */
	tpf_res_pie_sec[MVT_DEP_SIM]	= NULL;            /* deplacement simple*/
	tpf_res_pie_sec[MVT_PRI_SIM]	= pie_sup_res;     /* prise simple 		*/
	tpf_res_pie_sec[MVT_PIO_REI]	= pio_res;
	tpf_res_pie_sec[MVT_PIO_TOU]	= pio_res;
	tpf_res_pie_sec[MVT_PIO_FOU]	= pio_res;
	tpf_res_pie_sec[MVT_PIO_CAV]	= pio_res;
	tpf_res_pie_sec[MVT_PRI_PIO_REI]= pri_pio_res;
	tpf_res_pie_sec[MVT_PRI_PIO_TOU]= pri_pio_res;
	tpf_res_pie_sec[MVT_PRI_PIO_FOU]= pri_pio_res;
	tpf_res_pie_sec[MVT_PRI_PIO_CAV]= pri_pio_res;
	tpf_res_pie_sec[MVT_PRI_PAS] 	= pie_sup_res;      /* prise en passant */
	tpf_res_pie_sec[MVT_PET_ROC] 	= tou_pet_roc_res;  /* petit rock 	    */
	tpf_res_pie_sec[MVT_GRA_ROC] 	= tou_grd_roc_res;  /* grand rock	    */

	/* type de mouvement prise */
	ti_typ_mvt_pri[MVT_DEP_SIM] 	= 0;
	ti_typ_mvt_pri[MVT_PRI_SIM] 	= 1;
	ti_typ_mvt_pri[MVT_PIO_REI] 	= 0;
	ti_typ_mvt_pri[MVT_PIO_TOU] 	= 0;
	ti_typ_mvt_pri[MVT_PIO_FOU] 	= 0;
	ti_typ_mvt_pri[MVT_PIO_CAV] 	= 0;
	ti_typ_mvt_pri[MVT_PRI_PIO_REI] = 1;
	ti_typ_mvt_pri[MVT_PRI_PIO_TOU] = 1;
	ti_typ_mvt_pri[MVT_PRI_PIO_FOU] = 1;
	ti_typ_mvt_pri[MVT_PRI_PIO_CAV] = 1;
	ti_typ_mvt_pri[MVT_PRI_PAS]		= 1;
	ti_typ_mvt_pri[MVT_PET_ROC]		= 0;
	ti_typ_mvt_pri[MVT_GRA_ROC] 	= 0;

	/* chargement du tableau (statique) controle a nouveau echec / demasquge*/
	tpf_cas_ctl_sta[0] = NULL;
	tpf_cas_ctl_sta[1] = cas_ctl_h_d;
	tpf_cas_ctl_sta[2] = cas_ctl_h_g;
	tpf_cas_ctl_sta[3] = cas_ctl_b_d;
	tpf_cas_ctl_sta[4] = cas_ctl_b_g;

	tpf_cas_ctl_sta[5] = cas_ctl_h;
	tpf_cas_ctl_sta[6] = cas_ctl_b;
	tpf_cas_ctl_sta[7] = cas_ctl_d;
	tpf_cas_ctl_sta[8] = cas_ctl_g;

	tpf_cas_ctl_sta[9]  = cas_ctl_cav_h_d;
	tpf_cas_ctl_sta[10] = cas_ctl_cav_d_h;
	tpf_cas_ctl_sta[11] = cas_ctl_cav_d_b;
	tpf_cas_ctl_sta[12] = cas_ctl_cav_b_d;
	tpf_cas_ctl_sta[13] = cas_ctl_cav_b_g;
	tpf_cas_ctl_sta[14] = cas_ctl_cav_g_b;
	tpf_cas_ctl_sta[15] = cas_ctl_cav_g_h;
	tpf_cas_ctl_sta[16] = cas_ctl_cav_h_g;

	tpf_cas_ctl_sta[17] = cas_ctl_pio_d;
	tpf_cas_ctl_sta[18] = cas_ctl_pio_g;

	tpf_cas_ctl_sta[19] = cas_ctl_roi_h;
	tpf_cas_ctl_sta[20] = cas_ctl_roi_h_d;
	tpf_cas_ctl_sta[21] = cas_ctl_roi_d;
	tpf_cas_ctl_sta[22] = cas_ctl_roi_b_d;
	tpf_cas_ctl_sta[23] = cas_ctl_roi_b;
	tpf_cas_ctl_sta[24] = cas_ctl_roi_b_g;
	tpf_cas_ctl_sta[25] = cas_ctl_roi_g;
	tpf_cas_ctl_sta[26] = cas_ctl_roi_h_g;



	/* tableau de correpondance coordonn cavalier/roi <-> ech_dir */
	ti_ech_dir_cav[1][0]= 9;
	ti_ech_dir_cav[0][1]= 10;
	ti_ech_dir_cav[0][3]= 11;
	ti_ech_dir_cav[1][4]= 12;
	ti_ech_dir_cav[3][4]= 13;
	ti_ech_dir_cav[4][3]= 14;
	ti_ech_dir_cav[4][1]= 15;
	ti_ech_dir_cav[3][0]= 16;

	/* chargement du tableau de camp */
	tpts_pie[0]= ts_pie_0;
	tpts_pie[1]= ts_pie_1;


	/* initialisation tableau echiquier */
	/* hors limite cam = -2, ID = -1    */
		for (x=0;x<12;x++)
	{
		for (y=0;y<12;y++)
		{
			ts_ech[x][y].i_cam = -2; ts_ech[x][y].i_Id = -1;
		}
	}
	 /* dans limite cam = -1, ID = -1    */
		for (x=2;x<10;x++)
	{
		for (y=2;y<10;y++)
		{
			ts_ech[x][y].i_cam = -1;
		}
	}


	/* initialisation tableau piece  */
	ts_pie_0[0].i_pie_sui=17;
	ts_pie_0[17].i_pie_pre=0;
	ts_pie_1[0].i_pie_sui=17;
	ts_pie_1[17].i_pie_pre=0;


	 /* ajout des pices sur l'chiquier */

	 err =ajo_pie(0,'t',1,1);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(0,'c',2,1);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(0,'f',3,1);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(0,'d',4,1);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(0,'r',5,1);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(0,'f',6,1);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(0,'c',7,1);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(0,'t',8,1);   if (err != 0)  printf("Erreur : %i\n",err);

	 err =ajo_pie(0,'p',1,2);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(0,'p',2,2);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(0,'p',3,2);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(0,'p',4,2);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(0,'p',5,2);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(0,'p',6,2);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(0,'p',7,2);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(0,'p',8,2);   if (err != 0)  printf("Erreur : %i\n",err);

	 err =ajo_pie(1,'t',1,8);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(1,'c',2,8);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(1,'f',3,8);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(1,'d',4,8);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(1,'r',5,8);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(1,'f',6,8);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(1,'c',7,8);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(1,'t',8,8);   if (err != 0)  printf("Erreur : %i\n",err);

	 err =ajo_pie(1,'p',1,7);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(1,'p',2,7);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(1,'p',3,7);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(1,'p',4,7);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(1,'p',5,7);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(1,'p',6,7);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(1,'p',7,7);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(1,'p',8,7);   if (err != 0)  printf("Erreur : %i\n",err);



}

/*  Ajouter piece  */
int ajo_pie (int i_cam,char c_cod_pie,int i_coo_x, int i_coo_y)
{

	int i_Id_pre,i_Id_nou;			/* N de piece precedement ajout,et    */
													/* ajouter       						 */
	struct st_pie  	*pts_pie_ajo;	/* ptr tableau struct pice */

	if (i_cam != 0 && i_cam != 1) return 1;         /* N camp invalide */

	i_Id_pre =(tpts_pie[i_cam]+17)->i_pie_pre;
	i_Id_nou = i_Id_pre;
	i_Id_nou++;
	if (i_Id_pre == 16)
		return 2;                                   /* Nombre de pice max atteint */
	else
		pts_pie_ajo = tpts_pie[i_cam]+i_Id_nou;

	if (i_coo_x <0 || i_coo_x>8 || i_coo_y <0|| i_coo_y>8)
		return 3;                                   /* Coordone pice invalide */
	else
	{
		i_coo_x ++;
		i_coo_y ++;

	}

	if (ts_ech[i_coo_x][i_coo_y].i_Id != -1)         /* case dj occupe */
	   return 5;
	switch (c_cod_pie)
	{

		case 'r':
					pts_pie_ajo->i_for  		= 0;
					pts_pie_ajo->pf_ini_hst_mvt	= ini_hst_mvt_roi;
					pts_pie_ajo->pf_jou 		= jou_roi;
					pts_pie_ajo->pf_ech_par		= 0;
					pts_pie_ajo->i_mvt_uni_dir	= 1;
					Id_roi[i_cam] 				=i_Id_nou;
					pts_pie_ajo->c_typ_pie		= 'R';
					if (i_cam == 0)
						pts_pie_ajo->c_lib_pie	= 'R';
					else
						pts_pie_ajo->c_lib_pie	= 'r';
					break;

		case 'd':
					pts_pie_ajo->i_for  		= 4;
					pts_pie_ajo->pf_ini_hst_mvt	= ini_hst_mvt_rei;
					pts_pie_ajo->pf_jou 		= jou_ctfr;
					pts_pie_ajo->pf_ech_par		= ech_par_rei;
					pts_pie_ajo->i_mvt_uni_dir	= 0;
					pts_pie_ajo->c_typ_pie		= 'D';
					if (i_cam == 0)
						pts_pie_ajo->c_lib_pie	= 'D';
					else
						pts_pie_ajo->c_lib_pie	= 'd';
					break;

		case 'f':
					pts_pie_ajo->i_for  		= 3;
					pts_pie_ajo->pf_ini_hst_mvt	= ini_hst_mvt_fou;
					pts_pie_ajo->pf_jou 		= jou_ctfr;
					pts_pie_ajo->pf_ech_par		= ech_par_fou;
					pts_pie_ajo->i_mvt_uni_dir	= 0;
					pts_pie_ajo->c_typ_pie		= 'F';
					if (i_cam == 0)
						pts_pie_ajo->c_lib_pie	= 'F';
					else
						pts_pie_ajo->c_lib_pie	= 'f';
					break;
		case 't':
					pts_pie_ajo->i_for  		= 3;
					pts_pie_ajo->pf_ini_hst_mvt	= ini_hst_mvt_tou;
					pts_pie_ajo->pf_jou 		= jou_ctfr;
					pts_pie_ajo->pf_ech_par		= ech_par_tou;
					pts_pie_ajo->i_mvt_uni_dir  = 0;
					pts_pie_ajo->c_typ_pie		= 'T';
					if (i_cam == BLANC)
					{
						pts_pie_ajo->c_lib_pie	= 'T';
						if
						(
						i_coo_x == 2
						&&
						i_coo_y == 2
						)
						ti_tou_cam_typ [BLANC][GRA_ROC]=i_Id_nou;
						if
						(
						i_coo_x == 9
						&&
						i_coo_y == 2
						)
						ti_tou_cam_typ [BLANC][PET_ROC]=i_Id_nou;
					}
					else
					{
						pts_pie_ajo->c_lib_pie	= 't';
						if
						(
						i_coo_x == 2
						&&
						i_coo_y == 9
						)
						ti_tou_cam_typ [NOIR][GRA_ROC]=i_Id_nou;
						if
						(
						i_coo_x == 9
						&&
						i_coo_y == 9
						)
						ti_tou_cam_typ [NOIR][PET_ROC]=i_Id_nou;
					}
					break;
		case 'c':
					pts_pie_ajo->i_for  		= 2;
					pts_pie_ajo->pf_ini_hst_mvt	= ini_hst_mvt_cav;
					pts_pie_ajo->pf_jou 		= jou_ctfr;
					pts_pie_ajo->pf_ech_par		= ech_par_cav;
					pts_pie_ajo->i_mvt_uni_dir  = 1;
					pts_pie_ajo->c_typ_pie		= 'C';
					if (i_cam == 0)
						pts_pie_ajo->c_lib_pie	= 'C';
					else
						pts_pie_ajo->c_lib_pie	= 'c';
					break;
		case 'p':
					pts_pie_ajo->i_for  		= 1;
					pts_pie_ajo->i_mvt_uni_dir	= 1;
					pts_pie_ajo->c_typ_pie	= 'P';
					if (i_cam == BLANC)
					{
						pts_pie_ajo->pf_ini_hst_mvt	= ini_hst_mvt_pio_0;
						pts_pie_ajo->pf_jou 		= jou_pio_0;
						pts_pie_ajo->pf_ech_par		= ech_par_pio_0;
						pts_pie_ajo->c_lib_pie		= 'P';
					}
					else
					{
						pts_pie_ajo->pf_ini_hst_mvt	= ini_hst_mvt_pio_1;
						pts_pie_ajo->pf_jou 		= jou_pio_1;
						pts_pie_ajo->pf_ech_par		= ech_par_pio_1;
						pts_pie_ajo->c_lib_pie		= 'p';
					}
					break;
		default  :
					return 5;
				 /*	break;  */
	}

	/* Mise  jour coordonnes */
	pts_pie_ajo->i_pos_x 	= i_coo_x ;
	pts_pie_ajo->i_pos_y 	= i_coo_y;

	/* Mise  jour tableau echiquier */
	ts_ech[i_coo_x][i_coo_y].i_cam = i_cam;
	ts_ech[i_coo_x][i_coo_y].i_Id = i_Id_nou;

	/* Insertion piece dans tableau pices */
	pts_pie_ajo->i_pie_sui 	= 17 ;
	pts_pie_ajo->i_pie_pre 	= i_Id_pre;
	(tpts_pie[i_cam]+i_Id_pre)->i_pie_sui = i_Id_nou ;
	(tpts_pie[i_cam]+17)->i_pie_pre = i_Id_nou;

	return 0;

}

